#ifdef _MSC_VER
#pragma warning ( push )
#pragma warning ( disable:4005 ) // '_WIN32_WINNT' : macro redefinition
#define _WIN32_WINNT 0x0500
#pragma warning ( pop )
#endif




#include "rpc.h"
#include "rpcndr.h"

#ifndef __RPCNDR_H_VERSION__
#error this stub requires an updated version of <rpcndr.h>
#endif // __RPCNDR_H_VERSION__


#ifndef __vl_camcal_h__
#define __vl_camcal_h__

#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

/* Forward Declarations */ 

/* header files for imported files */
#include "vl_base.h"

#ifdef __cplusplus
extern "C"{
#endif 

void * __RPC_USER MIDL_user_allocate(size_t);
void __RPC_USER MIDL_user_free( void * ); 

/* interface __MIDL_itf_vl_camcal_0000 */
/* [local] */ 

//=--------------------------------------------------------------------------=
// (C) Copyright 2002-2010 MATRIX VISION GmbH.  All Rights Reserved.
// (C) Copyright 2002-2010 Impuls computergesttzte Bildanalyse GmbH.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//=--------------------------------------------------------------------------=

#if defined(__BORLANDC__)
#pragma option -b
#endif
#if !defined(NO_VL_CAMCAL_AUTOLINK)
#if defined(__BORLANDC__)
#pragma comment(lib,"vlb_camcal.lib")
#pragma message ("Automatically linking with vlb_camcal.lib")
#else
#if defined(_M_X64)
#if _MSC_VER >= 1500
#pragma comment(lib,"vl_camcal.lib")
#pragma message ("Automatically linking with vl_camcal.lib")
#else
#pragma comment(lib,"vl_camcal64.lib")
#pragma message ("Automatically linking with vl_camcal64.lib")
#endif
#else
#pragma comment(lib,"vl_camcal.lib")
#pragma message ("Automatically linking with vl_camcal.lib")
#endif
#endif
#endif


#ifdef MVIMPACT_H_ // include guard of the main C++ header
namespace mvIMPACT {
	namespace mvIMPACT_C {
#endif // #ifdef MVIMPACT_H_

#ifdef VL_CAMCAL_COMPILING
// when compiling the dll
#define VL_CAMCAL_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllexport)
#else
// when using the dll
#define VL_CAMCAL_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllimport)
#endif


extern RPC_IF_HANDLE __MIDL_itf_vl_camcal_0000_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_camcal_0000_v0_0_s_ifspec;


#ifndef __vl_camcal_LIBRARY_DEFINED__
#define __vl_camcal_LIBRARY_DEFINED__

/* library vl_camcal */
/* [helpstring][version][uuid] */ 

typedef IPL_BUFHANDLE CC_BUFHANDLE;

/* [helpstring] */ 
enum ECC_ERROR
    {	CC_ERR_WRONG_BUFHANDLE	= -4300,
	CC_ERR_WRONG_IMGHANDLE	= -4301,
	CC_ERR_WRONG_INPUTDATA	= -4302,
	CC_ERR_WRONG_IN_POINT_CNT	= -4303,
	CC_ERR_WRONG_OUTPUT_PTR	= -4304,
	CC_ERR_WRONG_BUFFER_PTR	= -4305,
	CC_ERR_UNKNOWN_PARAM	= -4306,
	CC_ERR_RO_PARAM	= -4307,
	CC_ERR_OUT_OF_RANGE	= -4308,
	CC_ERR_INTERNAL_ERR	= -4309,
	CC_ERR_NO_GRID_PTS	= -4310,
	CC_ERR_NO_CALIBRATION_DATA	= -4311,
	CC_ERR_MAX_NB_OF_ITRE_REACHED	= -4312,
	CC_ERR_TO_SMALL_TOLERANCE	= -4313,
	CC_ERR_NO_FILE_FOUND	= -4314,
	CC_ERR_INTERNAL_SORT_ERR	= -4315,
	CC_ERR_PREPARE_SORT	= -4316
    } ;
typedef /* [public] */ enum ECC_ERROR CC_ERROR;

/* [helpstring] */ 
enum ECC_CONTROL
    {	CC_NO_CTRL	= 0,
	CC_RW_DX	= CC_NO_CTRL + 1,
	CC_RW_DY	= CC_RW_DX + 1,
	CC_RW_TOLERANCE	= CC_RW_DY + 1,
	CC_RW_COORDINATE_SYSTEM	= CC_RW_TOLERANCE + 1,
	CC_RW_MIN_GRID_AREA	= CC_RW_COORDINATE_SYSTEM + 1,
	CC_RW_MAX_GRID_AREA	= CC_RW_MIN_GRID_AREA + 1,
	CC_RW_MAX_GRIDPT_CNT	= CC_RW_MAX_GRID_AREA + 1,
	CC_RW_MAX_ITER_NR	= CC_RW_MAX_GRIDPT_CNT + 1,
	CC_RO_ITER_CNT	= CC_RW_MAX_ITER_NR + 1,
	CC_RW_THRESHOLD	= CC_RO_ITER_CNT + 1,
	CC_RW_POLARITY	= CC_RW_THRESHOLD + 1,
	CC_RW_CALIBRATION_TYPE	= CC_RW_POLARITY + 1,
	CC_RW_BACKGROUND_VALUE	= CC_RW_CALIBRATION_TYPE + 1,
	CC_RW_WORLD_UNIT	= CC_RW_BACKGROUND_VALUE + 1,
	CC_RO_STATISTICS	= CC_RW_WORLD_UNIT + 1,
	CC_RW_ROI	= CC_RO_STATISTICS + 1,
	CC_RW_INTERPOLATION_TYPE	= CC_RW_ROI + 1,
	CC_RO_HAVE_CALIB_DATA	= CC_RW_INTERPOLATION_TYPE + 1,
	CC_RW_SCALE_XFACT	= CC_RO_HAVE_CALIB_DATA + 1,
	CC_RW_SCALE_YFACT	= CC_RW_SCALE_XFACT + 1,
	CC_RW_LINE_ANGLE_TOLERANCE	= CC_RW_SCALE_YFACT + 1,
	CC_LAST_CTRL	= CC_RW_LINE_ANGLE_TOLERANCE + 1
    } ;
typedef /* [hidden] */ enum ECC_CONTROL CC_CONTROL;


enum ECC_CALIB_TYPE
    {	CC_CALIB_AUTO	= 0,
	CC_SCALING	= CC_CALIB_AUTO + 1,
	CC_PERSPECTIVE	= CC_SCALING + 1,
	CC_DISTOR	= CC_PERSPECTIVE + 1
    } ;
typedef /* [hidden] */ enum ECC_CALIB_TYPE CC_CALIB_TYPE;


enum ECC_ORIENTATION
    {	CC_ORIENTATION_NORMAL	= 0,
	CC_ORIENTATION_INVERSE	= CC_ORIENTATION_NORMAL + 1
    } ;
typedef /* [hidden] */ enum ECC_ORIENTATION CC_ORIENTATION;


enum ECC_WORLD_UNIT
    {	CC_WU_MM	= 0,
	CC_WU_CM	= CC_WU_MM + 1,
	CC_WU_M	= CC_WU_CM + 1
    } ;
typedef /* [hidden] */ enum ECC_WORLD_UNIT CC_WORLD_UNIT;

struct SCC_COORDSYST
    {
    IPL_POINT_DOUBLE orig;
    IPL_DOUBLE angle;
    CC_ORIENTATION orientation;
    } ;
typedef struct SCC_COORDSYST CC_COORDSYST;

struct SCC_STATISTICS
    {
    IPL_DOUBLE dxavg;
    IPL_DOUBLE dyavg;
    IPL_DOUBLE euclavg;
    IPL_DOUBLE xstddev;
    IPL_DOUBLE ystddev;
    IPL_DOUBLE euclstddev;
    } ;
typedef struct SCC_STATISTICS CC_STATISTICS;


EXTERN_C const IID LIBID_vl_camcal;


#ifndef __vl_camcal_MODULE_DEFINED__
#define __vl_camcal_MODULE_DEFINED__


/* module vl_camcal */
/* [dllname][uuid] */ 

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_BufAlloc( 
    /* [full][out] */ CC_BUFHANDLE *bHandle,
    /* [in] */ const IPL_LONG falgs);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_BufFree( 
    /* [in] */ const CC_BUFHANDLE bHandle);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_GetGridPointsFromImage( 
    /* [in] */ const CC_BUFHANDLE bHandle,
    /* [in] */ const IPL_BUFHANDLE ImgHandle,
    /* [full][out][in] */ IPL_POINT_DOUBLE *pImagePlanePts,
    /* [full][out] */ IPL_ULONG *pPtsCnt);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_TeachCalibrationByGrid( 
    /* [in] */ const CC_BUFHANDLE bHandle,
    /* [in] */ const IPL_BUFHANDLE ImgHandle);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_TeachCalibrationByPoints( 
    /* [in] */ const CC_BUFHANDLE bHandle,
    /* [full][in] */ const IPL_POINT_DOUBLE *pImagePlanePts,
    /* [full][in] */ const IPL_POINT_DOUBLE *pObjectSpacePts,
    /* [in] */ const IPL_ULONG ulPtsCnt);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_TeachCalibrationBy3DPoints( 
    /* [in] */ const CC_BUFHANDLE bHandle,
    /* [full][in] */ const IPL_POINT_DOUBLE *pImagePlanePts,
    /* [full][in] */ const IPL_POINT3D_DOUBLE *pObjectSpacePts,
    /* [in] */ const IPL_ULONG ulPtsCnt);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_TrObjectSpace2ImagePlane( 
    /* [in] */ const CC_BUFHANDLE bHandle,
    /* [full][in] */ const IPL_POINT_DOUBLE *pObjectSpacePts,
    /* [full][out] */ IPL_POINT_DOUBLE *pImagePlanePts,
    /* [in] */ const IPL_ULONG ulPtsCnt);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_TrImagePlane2ObjectSpace( 
    /* [in] */ const CC_BUFHANDLE bHandle,
    /* [full][in] */ const IPL_POINT_DOUBLE *pImagePlanePts,
    /* [full][out] */ IPL_POINT_DOUBLE *pObjectSpacePts,
    /* [in] */ const IPL_ULONG ulPtsCnt);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_TrCalibratedImage( 
    /* [in] */ const CC_BUFHANDLE bHandle,
    /* [in] */ const IPL_BUFHANDLE SrcImgHandle,
    /* [full][out] */ IPL_BUFHANDLE *pDstImgHandle);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_Tr2DCoordinatesTo3D( 
    /* [in] */ const CC_BUFHANDLE bHandle,
    /* [full][in] */ const IPL_POINT_DOUBLE *p2DCoordinates,
    /* [full][out] */ IPL_POINT3D_DOUBLE *p3DCoordinates,
    /* [in] */ const IPL_ULONG ulPtsCnt);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_Tr3DCoordinatesTo2D( 
    /* [in] */ const CC_BUFHANDLE bHandle,
    /* [full][in] */ const IPL_POINT3D_DOUBLE *p3DCoordinates,
    /* [full][out] */ IPL_POINT_DOUBLE *p2DCoordinates,
    /* [in] */ const unsigned long PtsCnt);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_Control( 
    /* [in] */ const CC_BUFHANDLE bHandle,
    /* [in] */ const CC_CONTROL Item,
    /* [full][in] */ IPL_CONST_VOID_PTR pValue);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_Inquire( 
    /* [in] */ const CC_BUFHANDLE bHandle,
    /* [in] */ const CC_CONTROL Item,
    /* [full][out] */ IPL_VOID_PTR pValue);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_WriteToFile( 
    /* [in] */ const CC_BUFHANDLE bHandle,
    /* [full][in] */ const IPL_CHAR *pFileName);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_ReadFromFile( 
    /* [out][in] */ CC_BUFHANDLE *bHandle,
    /* [full][in] */ const IPL_CHAR *pFileName);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_CheckLic( void);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall CC_GetVersion( 
    /* [full][in] */ const IPL_CHAR *Buffer,
    /* [in] */ IPL_INT Bytes);

#endif /* __vl_camcal_MODULE_DEFINED__ */
#endif /* __vl_camcal_LIBRARY_DEFINED__ */

/* interface __MIDL_itf_vl_camcal_0119 */
/* [local] */ 


#ifdef MVIMPACT_H_ // include guard of the main C++ header
	} // namespace mvIMPACT_C
} // namespace mvIMPACT
#endif // #ifdef MVIMPACT_H_



extern RPC_IF_HANDLE __MIDL_itf_vl_camcal_0119_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_camcal_0119_v0_0_s_ifspec;

/* Additional Prototypes for ALL interfaces */

/* end of Additional Prototypes */

#ifdef __cplusplus
}
#endif

#endif


