#ifdef _MSC_VER
#pragma warning ( push )
#pragma warning ( disable:4005 ) // '_WIN32_WINNT' : macro redefinition
#define _WIN32_WINNT 0x0500
#pragma warning ( pop )
#endif




#include "rpc.h"
#include "rpcndr.h"

#ifndef __RPCNDR_H_VERSION__
#error this stub requires an updated version of <rpcndr.h>
#endif // __RPCNDR_H_VERSION__


#ifndef __vl_color_h__
#define __vl_color_h__

#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

/* Forward Declarations */ 

/* header files for imported files */
#include "vl_base.h"

#ifdef __cplusplus
extern "C"{
#endif 

void * __RPC_USER MIDL_user_allocate(size_t);
void __RPC_USER MIDL_user_free( void * ); 

/* interface __MIDL_itf_vl_color_0000 */
/* [local] */ 

//=--------------------------------------------------------------------------=
// (C) Copyright 2002-2010 MATRIX VISION GmbH.  All Rights Reserved.
// (C) Copyright 1997-2010 Impuls computergesttzte Bildanalyse GmbH.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//=--------------------------------------------------------------------------=

#if defined(__BORLANDC__)
#pragma option -b
#endif
#if !defined(NO_VL_COLOR_AUTOLINK)
#if defined(__BORLANDC__)
#pragma comment(lib,"vlb_color.lib")
#pragma message ("Automatically linking with vlb_color.lib")
#else
#if defined(_M_X64)
#if _MSC_VER >= 1500
#pragma comment(lib,"vl_color.lib")
#pragma message ("Automatically linking with vl_color.lib")
#else
#pragma comment(lib,"vl_color64.lib")
#pragma message ("Automatically linking with vl_color64.lib")
#endif
#else
#pragma comment(lib,"vl_color.lib")
#pragma message ("Automatically linking with vl_color.lib")
#endif
#endif
#endif


#ifdef MVIMPACT_H_ // include guard of the main C++ header
namespace mvIMPACT {
	namespace mvIMPACT_C {
#endif // #ifdef MVIMPACT_H_

#ifdef VL_COLOR_COMPILING
// when compiling the dll
#define VL_COLOR_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllexport)
#else
// when using the dll
#define VL_COLOR_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllimport)
#endif
#define COL_SRC(id)		(id & COL_SRC_MASK)
#define COL_DST(id)		((id & COL_DST_MASK) >> 16)


extern RPC_IF_HANDLE __MIDL_itf_vl_color_0000_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_color_0000_v0_0_s_ifspec;


#ifndef __vl_color_LIBRARY_DEFINED__
#define __vl_color_LIBRARY_DEFINED__

/* library vl_color */
/* [helpstring][version][uuid] */ 

typedef IPL_COL_SPACE COL_SPACE;

/* [helpstring] */ 
enum COL_ERROR
    {	COL_E_INVALID_BANDS	= -500,
	COL_E_BUFWIDTH_MISMATCH	= -501,
	COL_E_BUFHEIGHT_MISMATCH	= -502,
	COL_E_SLICES_MISMATCH	= -503,
	COL_E_FRAMES_MISMATCH	= -504,
	COL_E_PARM_OUT_OF_RANGE	= -505,
	COL_E_INVALID_COLOR_MODEL	= -506,
	COL_E_INVALID_WAVELENGTH	= -507,
	COL_E_TWIST_INVALID	= -508
    } ;
typedef /* [hidden] */ enum COL_ERROR COL_ERROR;

/* [helpstring] */ 
enum COL_SPACE_SOURCE
    {	COL_SRC_MASK	= 0xffffL,
	COL_CMY_SRC	= COL_CMY,
	COL_GRAY_SRC	= COL_GRAY,
	COL_HLS_SRC	= COL_HLS,
	COL_HSV_SRC	= COL_HSV,
	COL_RGB_SRC	= COL_RGB,
	COL_XYZ601_SRC	= COL_XYZ601,
	COL_XYZ709_SRC	= COL_XYZ709,
	COL_XYZITU_SRC	= COL_XYZITU,
	COL_YCC601_SRC	= COL_YCC601,
	COL_YIQ_SRC	= COL_YIQ,
	COL_YUV_SRC	= COL_YUV,
	COL_BM_SRC	= COL_BAYER_MOSAIC
    } ;
typedef /* [hidden] */ enum COL_SPACE_SOURCE COL_SPACE_SOURCE;

/* [helpstring] */ 
enum COL_SPACE_DEST
    {	COL_DST_MASK	= COL_SRC_MASK << 16,
	COL_CMY_DST	= COL_CMY << 16,
	COL_GRAY_DST	= COL_GRAY << 16,
	COL_HLS_DST	= COL_HLS << 16,
	COL_HSV_DST	= COL_HSV << 16,
	COL_RGB_DST	= COL_RGB << 16,
	COL_XYZ601_DST	= COL_XYZ601 << 16,
	COL_XYZ709_DST	= COL_XYZ709 << 16,
	COL_XYZITU_DST	= COL_XYZITU << 16,
	COL_YCC601_DST	= COL_YCC601 << 16,
	COL_YIQ_DST	= COL_YIQ << 16,
	COL_YUV_DST	= COL_YUV << 16
    } ;
typedef /* [hidden] */ enum COL_SPACE_DEST COL_SPACE_DEST;

/* [helpstring] */ 
enum COL_CONVERSION
    {	COL_CMY2GRAY	= COL_CMY_SRC | COL_GRAY_DST,
	COL_CMY2HLS	= COL_CMY_SRC | COL_HLS_DST,
	COL_CMY2HSV	= COL_CMY_SRC | COL_HSV_DST,
	COL_CMY2RGB	= COL_CMY_SRC | COL_RGB_DST,
	COL_CMY2XYZ601	= COL_CMY_SRC | COL_XYZ601_DST,
	COL_CMY2XYZ709	= COL_CMY_SRC | COL_XYZ709_DST,
	COL_CMY2XYZITU	= COL_CMY_SRC | COL_XYZITU_DST,
	COL_CMY2YCC601	= COL_CMY_SRC | COL_YCC601_DST,
	COL_CMY2YIQ	= COL_CMY_SRC | COL_YIQ_DST,
	COL_CMY2YUV	= COL_CMY_SRC | COL_YUV_DST,
	COL_GRAY2CMY	= COL_GRAY_SRC | COL_CMY_DST,
	COL_GRAY2HLS	= COL_GRAY_SRC | COL_HLS_DST,
	COL_GRAY2HSV	= COL_GRAY_SRC | COL_HSV_DST,
	COL_GRAY2RGB	= COL_GRAY_SRC | COL_RGB_DST,
	COL_GRAY2XYZ601	= COL_GRAY_SRC | COL_XYZ601_DST,
	COL_GRAY2XYZ709	= COL_GRAY_SRC | COL_XYZ709_DST,
	COL_GRAY2XYZITU	= COL_GRAY_SRC | COL_XYZITU_DST,
	COL_GRAY2YCC601	= COL_GRAY_SRC | COL_YCC601_DST,
	COL_GRAY2YIQ	= COL_GRAY_SRC | COL_YIQ_DST,
	COL_GRAY2YUV	= COL_GRAY_SRC | COL_YUV_DST,
	COL_HLS2CMY	= COL_HLS_SRC | COL_CMY_DST,
	COL_HLS2GRAY	= COL_HLS_SRC | COL_GRAY_DST,
	COL_HLS2HSV	= COL_HLS_SRC | COL_HSV_DST,
	COL_HLS2RGB	= COL_HLS_SRC | COL_RGB_DST,
	COL_HLS2XYZ601	= COL_HLS_SRC | COL_XYZ601_DST,
	COL_HLS2XYZ709	= COL_HLS_SRC | COL_XYZ709_DST,
	COL_HLS2XYZITU	= COL_HLS_SRC | COL_XYZITU_DST,
	COL_HLS2YCC601	= COL_HLS_SRC | COL_YCC601_DST,
	COL_HLS2YIQ	= COL_HLS_SRC | COL_YIQ_DST,
	COL_HLS2YUV	= COL_HLS_SRC | COL_YUV_DST,
	COL_HSV2CMY	= COL_HSV_SRC | COL_CMY_DST,
	COL_HSV2GRAY	= COL_HSV_SRC | COL_GRAY_DST,
	COL_HSV2HLS	= COL_HSV_SRC | COL_HLS_DST,
	COL_HSV2RGB	= COL_HSV_SRC | COL_RGB_DST,
	COL_HSV2XYZ601	= COL_HSV_SRC | COL_XYZ601_DST,
	COL_HSV2XYZ709	= COL_HSV_SRC | COL_XYZ709_DST,
	COL_HSV2XYZITU	= COL_HSV_SRC | COL_XYZITU_DST,
	COL_HSV2YCC601	= COL_HSV_SRC | COL_YCC601_DST,
	COL_HSV2YIQ	= COL_HSV_SRC | COL_YIQ_DST,
	COL_HSV2YUV	= COL_HSV_SRC | COL_YUV_DST,
	COL_RGB2CMY	= COL_RGB_SRC | COL_CMY_DST,
	COL_RGB2GRAY	= COL_RGB_SRC | COL_GRAY_DST,
	COL_RGB2HLS	= COL_RGB_SRC | COL_HLS_DST,
	COL_RGB2HSV	= COL_RGB_SRC | COL_HSV_DST,
	COL_RGB2XYZ601	= COL_RGB_SRC | COL_XYZ601_DST,
	COL_RGB2XYZ709	= COL_RGB_SRC | COL_XYZ709_DST,
	COL_RGB2XYZITU	= COL_RGB_SRC | COL_XYZITU_DST,
	COL_RGB2YCC601	= COL_RGB_SRC | COL_YCC601_DST,
	COL_RGB2YIQ	= COL_RGB_SRC | COL_YIQ_DST,
	COL_RGB2YUV	= COL_RGB_SRC | COL_YUV_DST,
	COL_XYZ6012CMY	= COL_XYZ601_SRC | COL_CMY_DST,
	COL_XYZ6012GRAY	= COL_XYZ601_SRC | COL_GRAY_DST,
	COL_XYZ6012HLS	= COL_XYZ601_SRC | COL_HLS_DST,
	COL_XYZ6012HSV	= COL_XYZ601_SRC | COL_HSV_DST,
	COL_XYZ6012RGB	= COL_XYZ601_SRC | COL_RGB_DST,
	COL_XYZ6012XYZ709	= COL_XYZ601_SRC | COL_XYZ709_DST,
	COL_XYZ6012XYZITU	= COL_XYZ601_SRC | COL_XYZITU_DST,
	COL_XYZ6012YCC601	= COL_XYZ601_SRC | COL_YCC601_DST,
	COL_XYZ6012YIQ	= COL_XYZ601_SRC | COL_YIQ_DST,
	COL_XYZ6012YUV	= COL_XYZ601_SRC | COL_YUV_DST,
	COL_XYZ7092CMY	= COL_XYZ709_SRC | COL_CMY_DST,
	COL_XYZ7092GRAY	= COL_XYZ709_SRC | COL_GRAY_DST,
	COL_XYZ7092HLS	= COL_XYZ709_SRC | COL_HLS_DST,
	COL_XYZ7092HSV	= COL_XYZ709_SRC | COL_HSV_DST,
	COL_XYZ7092RGB	= COL_XYZ709_SRC | COL_RGB_DST,
	COL_XYZ7092XYZ601	= COL_XYZ709_SRC | COL_XYZ601_DST,
	COL_XYZ7092XYZITU	= COL_XYZ709_SRC | COL_XYZITU_DST,
	COL_XYZ7092YCC601	= COL_XYZ709_SRC | COL_YCC601_DST,
	COL_XYZ7092YIQ	= COL_XYZ709_SRC | COL_YIQ_DST,
	COL_XYZ7092YUV	= COL_XYZ709_SRC | COL_YUV_DST,
	COL_XYZITU2CMY	= COL_XYZITU_SRC | COL_CMY_DST,
	COL_XYZITU2GRAY	= COL_XYZITU_SRC | COL_GRAY_DST,
	COL_XYZITU2HLS	= COL_XYZITU_SRC | COL_HLS_DST,
	COL_XYZITU2HSV	= COL_XYZITU_SRC | COL_HSV_DST,
	COL_XYZITU2RGB	= COL_XYZITU_SRC | COL_RGB_DST,
	COL_XYZITU2XYZ601	= COL_XYZITU_SRC | COL_XYZ601_DST,
	COL_XYZITU2XYZ709	= COL_XYZITU_SRC | COL_XYZ709_DST,
	COL_XYZITU2YCC601	= COL_XYZITU_SRC | COL_YCC601_DST,
	COL_XYZITU2YIQ	= COL_XYZITU_SRC | COL_YIQ_DST,
	COL_XYZITU2YUV	= COL_XYZITU_SRC | COL_YUV_DST,
	COL_YCC6012CMY	= COL_YCC601_SRC | COL_CMY_DST,
	COL_YCC6012GRAY	= COL_YCC601_SRC | COL_GRAY_DST,
	COL_YCC6012HLS	= COL_YCC601_SRC | COL_HLS_DST,
	COL_YCC6012HSV	= COL_YCC601_SRC | COL_HSV_DST,
	COL_YCC6012RGB	= COL_YCC601_SRC | COL_RGB_DST,
	COL_YCC6012XYZ601	= COL_YCC601_SRC | COL_XYZ601_DST,
	COL_YCC6012XYZ709	= COL_YCC601_SRC | COL_XYZ709_DST,
	COL_YCC6012XYZITU	= COL_YCC601_SRC | COL_XYZITU_DST,
	COL_YCC6012YIQ	= COL_YCC601_SRC | COL_YIQ_DST,
	COL_YCC6012YUV	= COL_YCC601_SRC | COL_YUV_DST,
	COL_YIQ2CMY	= COL_YIQ_SRC | COL_CMY_DST,
	COL_YIQ2GRAY	= COL_YIQ_SRC | COL_GRAY_DST,
	COL_YIQ2HLS	= COL_YIQ_SRC | COL_HLS_DST,
	COL_YIQ2HSV	= COL_YIQ_SRC | COL_HSV_DST,
	COL_YIQ2RGB	= COL_YIQ_SRC | COL_RGB_DST,
	COL_YIQ2XYZ601	= COL_YIQ_SRC | COL_XYZ601_DST,
	COL_YIQ2XYZ709	= COL_YIQ_SRC | COL_XYZ709_DST,
	COL_YIQ2XYZITU	= COL_YIQ_SRC | COL_XYZITU_DST,
	COL_YIQ2YCC601	= COL_YIQ_SRC | COL_YCC601_DST,
	COL_YIQ2YUV	= COL_YIQ_SRC | COL_YUV_DST,
	COL_YUV2CMY	= COL_YUV_SRC | COL_CMY_DST,
	COL_YUV2GRAY	= COL_YUV_SRC | COL_GRAY_DST,
	COL_YUV2HLS	= COL_YUV_SRC | COL_HLS_DST,
	COL_YUV2HSV	= COL_YUV_SRC | COL_HSV_DST,
	COL_YUV2RGB	= COL_YUV_SRC | COL_RGB_DST,
	COL_YUV2XYZ601	= COL_YUV_SRC | COL_XYZ601_DST,
	COL_YUV2XYZ709	= COL_YUV_SRC | COL_XYZ709_DST,
	COL_YUV2XYZITU	= COL_YUV_SRC | COL_XYZITU_DST,
	COL_YUV2YCC601	= COL_YUV_SRC | COL_YCC601_DST,
	COL_YUV2YIQ	= COL_YUV_SRC | COL_YIQ_DST,
	COL_BM2RGB	= COL_BM_SRC | COL_RGB_DST,
	COL_BM2YUV	= COL_BM_SRC | COL_YUV_DST,
	COL_BM2GRAY	= COL_BM_SRC | COL_GRAY_DST
    } ;
typedef /* [hidden] */ enum COL_CONVERSION COL_CONVERSION;

/* [helpstring] */ 
enum COL_THRESHOLD_MODE
    {	COL_OR_CHANNELS	= 0,
	COL_AND_CHANNELS	= 1,
	COL_INVERT	= 2
    } ;
typedef /* [hidden] */ enum COL_THRESHOLD_MODE COL_THRESHOLD_MODE;


EXTERN_C const IID LIBID_vl_color;


#ifndef __vl_color_MODULE_DEFINED__
#define __vl_color_MODULE_DEFINED__


/* module vl_color */
/* [dllname][uuid] */ 

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_ColorTwist( 
    /* [in] */ IPL_BUFHANDLE Source,
    /* [full][out][in] */ IPL_BUFHANDLE *Destination,
    /* [size_is][in] */ const IPL_DOUBLE *Twist);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_ConvertColorSpace( 
    /* [in] */ IPL_BUFHANDLE Source,
    /* [full][out][in] */ IPL_BUFHANDLE *Destination,
    /* [in] */ COL_CONVERSION Colorspace);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_ExtractModel( 
    /* [string][full][in] */ const IPL_CHAR *Model,
    /* [in] */ IPL_ULONG Band,
    /* [size_is][full][out] */ IPL_CHAR *Extract,
    /* [in] */ IPL_ULONG Length);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_ModelTinting( 
    /* [string][full][in] */ const IPL_CHAR *Model,
    /* [full][out][in] */ IPL_BUFHANDLE *Palette);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_ModelToLong( 
    /* [string][full][in] */ const IPL_CHAR *Model,
    /* [size_is][full][out] */ IPL_CHAR *LongForm,
    /* [in] */ IPL_ULONG Length);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_ModelToShort( 
    /* [string][full][in] */ const IPL_CHAR *Model,
    /* [size_is][full][out] */ IPL_CHAR *ShortForm,
    /* [in] */ IPL_ULONG Length);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_SpectralToColor( 
    /* [in] */ IPL_ULONG Wavelength,
    /* [in] */ COL_SPACE Colorspace,
    /* [full][out] */ IPL_DOUBLE *TristimulusA,
    /* [full][out] */ IPL_DOUBLE *TristimulusB,
    /* [full][out] */ IPL_DOUBLE *TristimulusC);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_GetColorSpaceID( 
    /* [string][full][in] */ const IPL_CHAR *Model,
    /* [full][out] */ COL_SPACE *Colorspace);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_GetModelFromID( 
    /* [in] */ COL_SPACE Colorspace,
    /* [size_is][full][out] */ IPL_CHAR *Model,
    /* [in] */ IPL_ULONG Length);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_Threshold( 
    /* [in] */ IPL_BUFHANDLE Source,
    /* [full][out][in] */ IPL_BUFHANDLE *Destination,
    /* [in] */ COL_SPACE Colorspace,
    /* [in] */ COL_SPACE Thresholdspace,
    /* [in] */ IPL_ULONG Channel1Lower,
    /* [in] */ IPL_ULONG Channel1Upper,
    /* [in] */ IPL_ULONG Channel2Lower,
    /* [in] */ IPL_ULONG Channel2Upper,
    /* [in] */ IPL_ULONG Channel3Lower,
    /* [in] */ IPL_ULONG Channel3Upper,
    /* [in] */ COL_THRESHOLD_MODE Mode);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_ConvertToColor( 
    /* [in] */ IPL_BUFHANDLE Source,
    /* [full][out][in] */ IPL_BUFHANDLE *Destination,
    /* [in] */ const IPL_DOUBLE Red,
    /* [in] */ const IPL_DOUBLE Green,
    /* [in] */ const IPL_DOUBLE Blue);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_ConvertToGrayscale( 
    /* [in] */ IPL_BUFHANDLE Source,
    /* [full][out][in] */ IPL_BUFHANDLE *Destination,
    /* [in] */ const IPL_DOUBLE Red,
    /* [in] */ const IPL_DOUBLE Green,
    /* [in] */ const IPL_DOUBLE Blue);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_CheckLic( void);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_GetVersion( 
    /* [full][in] */ const IPL_CHAR *Buffer,
    /* [in] */ IPL_INT Bytes);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_CalcColorDistanceImage( 
    /* [in] */ IPL_BUFHANDLE SrcHandle,
    /* [full][out][in] */ IPL_BUFHANDLE *DstHandle,
    /* [in] */ IPL_COLOR RGBColor1,
    /* [in] */ IPL_COLOR RGBColor2);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall COL_GetMaxContrastPlane( 
    IPL_BUFHANDLE SrcHandle,
    IPL_BUFHANDLE *DstHandle,
    COL_CONVERSION *Conversions,
    IPL_ULONG nConversions,
    IPL_LINE Line,
    IPL_ULONG LineWidth,
    IPL_ULONG EdgeWidth);

#endif /* __vl_color_MODULE_DEFINED__ */
#endif /* __vl_color_LIBRARY_DEFINED__ */

/* interface __MIDL_itf_vl_color_0119 */
/* [local] */ 


#ifdef MVIMPACT_H_ // include guard of the main C++ header
	} // namespace mvIMPACT_C
} // namespace mvIMPACT
#endif // #ifdef MVIMPACT_H_



extern RPC_IF_HANDLE __MIDL_itf_vl_color_0119_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_color_0119_v0_0_s_ifspec;

/* Additional Prototypes for ALL interfaces */

/* end of Additional Prototypes */

#ifdef __cplusplus
}
#endif

#endif


