#include <vl_dummy.h>

#include <stdio.h>

int main(int /*argc*/, char** /*argv[]*/)
{
	IPL_CHAR answer[128];

	// The first call is supposed to work without error, since no license checks
	// are done within the DUMMY_Hello function.

	if (!DUMMY_Hello(answer, sizeof(answer)))
		printf("DUMMY_Hello failed: %s\n", IPL_GetErrorString(IPL_GetErrorCode()));
	else
		printf("DUMMY_Hello returned: %s\n\n", answer);

	// The subsequent calls will fail for licensing reasons, unless you have
	// patched the proper LAD files. This is because inside the vl_dummy lib
	// different types of licensing calls are made.

	// You can have a look inside patchlic.bat to see what needs to be done
	// in order to create the proper licenses. Please note that you need to
	// edit patchlic.bat to suit your needs. 

	printf("\n");
	printf("The subsequent calls will fail for licensing reasons, unless you ");
	printf("have patched the proper LAD files. This is because inside the ");
	printf("vl_dummy lib different types of licensing calls are made.\n\n");

	if (!DUMMY_Hello1(answer, sizeof(answer)))
		printf("DUMMY_Hello1 failed: %s\n", IPL_GetErrorString(IPL_GetErrorCode()));
	else
		printf("DUMMY_Hello1 returned: %s\n\n", answer);

	if (!DUMMY_Hello2(answer, sizeof(answer)))
		printf("DUMMY_Hello2 failed: %s\n", IPL_GetErrorString(IPL_GetErrorCode()));
	else
		printf("DUMMY_Hello2 returned: %s\n\n", answer);

	if (!DUMMY_Hello3(answer, sizeof(answer)))
		printf("DUMMY_Hello3 failed: %s\n", IPL_GetErrorString(IPL_GetErrorCode()));
	else
		printf("DUMMY_Hello3 returned: %s\n\n", answer);

	if (!DUMMY_Hello4(answer, sizeof(answer)))
		printf("DUMMY_Hello4 failed: %s\n", IPL_GetErrorString(IPL_GetErrorCode()));
	else
		printf("DUMMY_Hello4 returned: %s\n\n", answer);

	printf("\nPress any key to quit\n");
	IPL_CheckForInput(NULL, IPL_TRUE, IPL_FALSE, NULL);

	return 0;
}
