#! /bin/make
############################################
# 03.08.2002 td
# 23.03.2004 td (add OSTYPE)
#===========================================
#        == DO NOT CHANGE !!! ==
############################################
OSTYPE := $(shell uname | cut -d _ -f 1 | tr [:upper:] [:lower:])
HAVE_I386_PATH := $(shell pwd | grep linux)

ifeq ($(SUBDIRS),)
	ifeq ($(OSTYPE),cygwin)
		SUBDIRS=$(OSTYPE)
	else
		SUBDIRS=ppc603e
		###i386 arm
	endif
endif

#-------------------------------------------
.PHONY:	$(SUBDIRS) all build new info ipk

#-------------------------------------------
all info ipk:
	@if [ "$(HAVE_I386_PATH)" = "" ];							\
	then														\
		for dir in $(SUBDIRS);									\
		do														\
			mkdir -p $$dir;										\
			$(MAKE) -C $$dir -f ../Makefile.inc $@ || exit $$?;	\
		done;													\
	else														\
		mkdir -p i386;											\
		$(MAKE) -C i386 -f ../Makefile.inc $@ || exit $$?;		\
	fi

#-------------------------------------------
ppc603e ppc823 ppc i386 cygwin arm ppc_6xx:
	mkdir -p $@
	$(MAKE) -C $@ -f ../Makefile.inc all || exit $$?

#-------------------------------------------
clean:
	@rm -rf $(SUBDIRS)
	@rm -rf i386

#-------------------------------------------
build new:
	@for dir in $(SUBDIRS) ; do rm -rf $$dir; mkdir -p $$dir; $(MAKE) -C $$dir -f ../Makefile.inc $@ || exit $$?; done

#-------------------------------------------
