#ifdef _MSC_VER
#pragma warning ( push )
#pragma warning ( disable:4005 ) // '_WIN32_WINNT' : macro redefinition
#define _WIN32_WINNT 0x0500
#pragma warning ( pop )
#endif




#include "rpc.h"
#include "rpcndr.h"

#ifndef __RPCNDR_H_VERSION__
#error this stub requires an updated version of <rpcndr.h>
#endif // __RPCNDR_H_VERSION__


#ifndef __vl_blob_h__
#define __vl_blob_h__

#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

/* Forward Declarations */ 

/* header files for imported files */
#include "vl_base.h"
#include "vl_blobloc.h"

#ifdef __cplusplus
extern "C"{
#endif 

void * __RPC_USER MIDL_user_allocate(size_t);
void __RPC_USER MIDL_user_free( void * ); 

/* interface __MIDL_itf_vl_blob_0000 */
/* [local] */ 

//=--------------------------------------------------------------------------=
// (C) Copyright 2002-2010 MATRIX VISION GmbH.  All Rights Reserved.
// (C) Copyright 1997-2010 Impuls computergesttzte Bildanalyse GmbH.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//=--------------------------------------------------------------------------=

#if defined(__BORLANDC__)
#pragma option -b
#endif
#if !defined(NO_VL_BLOB_AUTOLINK)
#if defined(__BORLANDC__)
#pragma comment(lib,"vlb_blob.lib")
#pragma message ("Automatically linking with vlb_blob.lib")
#else
#if defined(_M_X64)
#if _MSC_VER >= 1500
#pragma comment(lib,"vl_blob.lib")
#pragma message ("Automatically linking with vl_blob.lib")
#else
#pragma comment(lib,"vl_blob64.lib")
#pragma message ("Automatically linking with vl_blob64.lib")
#endif
#else
#pragma comment(lib,"vl_blob.lib")
#pragma message ("Automatically linking with vl_blob.lib")
#endif
#endif
#endif


#ifdef MVIMPACT_H_ // include guard of the main C++ header
namespace mvIMPACT {
	namespace mvIMPACT_C {
#endif // #ifdef MVIMPACT_H_

#ifdef VL_BLOB_COMPILING
// when compiling the dll
#define VL_BLOB_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllexport)
#else
// when using the dll
#define VL_BLOB_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllimport)
#endif
#define	BL_DONT_CARE	( IPL_DONT_CARE )



extern RPC_IF_HANDLE __MIDL_itf_vl_blob_0000_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_blob_0000_v0_0_s_ifspec;


#ifndef __vl_blob_LIBRARY_DEFINED__
#define __vl_blob_LIBRARY_DEFINED__

/* library vl_blob */
/* [helpstring][version][uuid] */ 

typedef /* [helpstring] */ BLOC_HANDLE BL_OBJHANDLE;

typedef _BL_BUFHANDLE BL_BUFHANDLE;


enum BL_ERROR
    {	BL_ATTRIBUTE_ERROR	= -1200,
	BL_FEATURE_NOT_FOUND_ERROR	= -1201,
	BL_CALCULATION_ERROR	= -1202,
	BL_NO_VALID_DATA_ERROR	= -1203,
	BL_INVALID_PARAMETER_ERROR	= -1204,
	BL_INVALID_CONTROL_VALUE	= -1205,
	BL_HANDLE_ERROR	= -1206,
	BL_STOPPED_AFTER_INDEX	= -1207
    } ;
typedef /* [hidden] */ enum BL_ERROR BL_ERROR;


enum BL_BUFALLOCFLAGS
    {	BL_NONE	= 0,
	BL_FEATUREBUF	= 1,
	BL_RESULTBUF	= 2
    } ;
typedef /* [hidden] */ enum BL_BUFALLOCFLAGS BL_BUFALLOCFLAGS;


enum BL_FEATUREFLAGS
    {	BL_ADD	= 0,
	BL_REMOVE	= 1
    } ;
typedef /* [hidden] */ enum BL_FEATUREFLAGS BL_FEATUREFLAGS;


enum BL_INQUIREFLAGS
    {	BL_GET_NB_BLOBS	= 1,
	BL_GET_DATATYPE	= 2,
	BL_GET_NB_FEATURES	= 3,
	BL_GET_NB_ITEMS	= 4,
	BL_GET_NB_BANDS	= 5,
	BL_GET_NB_TIME_SLICES	= 6,
	BL_GET_NB_Z_SLICES	= 7
    } ;
typedef /* [hidden] */ enum BL_INQUIREFLAGS BL_INQUIREFLAGS;

typedef /* [hidden] */ enum BLOC_CONTROL BL_CONTROL;


enum BL_FEATURE
    {	BL_GET_LABELS	= 0,
	BL_AREA_FEAT	= 0x40000000L,
	BL_BIN_FEAT	= 0x10000000L,
	BL_GRAY_FEAT	= 0x20000000L,
	BL_GEN_FEAT	= 0x30000000L,
	BL_GRAYSCALE	= 0x20000L,
	BL_AR_AREA	= BL_AREA_FEAT | BL_BIN_FEAT | 0x1,
	BL_AR_PERIMETER	= BL_AREA_FEAT | BL_BIN_FEAT | 0x2,
	BL_AR_ROUNDNESS	= BL_AREA_FEAT | BL_BIN_FEAT | 0x3,
	BL_AR_EXTREME_BOX	= BL_AREA_FEAT | BL_BIN_FEAT | 0x4,
	BL_AR_FIRST_POINT	= BL_AREA_FEAT | BL_BIN_FEAT | 0x5,
	BL_AR_EULER_NUMBER	= BL_AREA_FEAT | BL_BIN_FEAT | 0x6,
	BL_AR_NUMBER_HOLES	= BL_AREA_FEAT | BL_BIN_FEAT | 0x7,
	BL_AR_MAJOR_AXIS	= BL_AREA_FEAT | BL_BIN_FEAT | 0x10,
	BL_AR_MAJOR_AXIS_ANGLE	= BL_AREA_FEAT | BL_BIN_FEAT | 0x11,
	BL_AR_MAJOR_AXIS_LENGTH	= BL_AREA_FEAT | BL_BIN_FEAT | 0x12,
	BL_AR_MINOR_AXIS	= BL_AREA_FEAT | BL_BIN_FEAT | 0x13,
	BL_AR_MINOR_AXIS_ANGLE	= BL_AREA_FEAT | BL_BIN_FEAT | 0x14,
	BL_AR_MINOR_AXIS_LENGTH	= BL_AREA_FEAT | BL_BIN_FEAT | 0x15,
	BL_AR_FERET_MAX	= BL_AREA_FEAT | BL_BIN_FEAT | 0x16,
	BL_AR_FERET_MAX_ANGLE	= BL_AREA_FEAT | BL_BIN_FEAT | 0x17,
	BL_AR_FERET_MIN	= BL_AREA_FEAT | BL_BIN_FEAT | 0x18,
	BL_AR_FERET_MIN_ANGLE	= BL_AREA_FEAT | BL_BIN_FEAT | 0x19,
	BL_AR_FERET_0	= BL_AREA_FEAT | BL_BIN_FEAT | 0x1a,
	BL_AR_FERET_90	= BL_AREA_FEAT | BL_BIN_FEAT | 0x1b,
	BL_AR_FERET_GEN	= BL_AREA_FEAT | BL_BIN_FEAT | 0x1c,
	BL_AR_FERET_RATIO	= BL_AREA_FEAT | BL_BIN_FEAT | 0x1e,
	BL_AR_PERIMETER_CONVEX	= BL_AREA_FEAT | BL_BIN_FEAT | 0x20,
	BL_AR_ROUGHNESS	= BL_AREA_FEAT | BL_BIN_FEAT | 0x21,
	BL_AR_AREA_CONVEX	= BL_AREA_FEAT | BL_BIN_FEAT | 0x22,
	BL_AR_AREA_HOLES	= BL_AREA_FEAT | BL_BIN_FEAT | 0x26,
	BL_AR_AREA_PERFORATION	= BL_AREA_FEAT | BL_BIN_FEAT | 0x27,
	BL_AR_AREA_HOLES_MEAN	= BL_AREA_FEAT | BL_BIN_FEAT | 0x28,
	BL_AR_FIBER_LENGTH	= BL_AREA_FEAT | BL_BIN_FEAT | 0x29,
	BL_AR_FIBER_WIDTH	= BL_AREA_FEAT | BL_BIN_FEAT | 0x2a,
	BL_AR_CONVEXHULL_POINTS	= BL_AREA_FEAT | BL_BIN_FEAT | 0x2c,
	BL_AR_NB_OUTLINE_POINTS	= BL_AREA_FEAT | BL_BIN_FEAT | 0x2d,
	BL_AR_OUTLINE_POINTS	= BL_AREA_FEAT | BL_BIN_FEAT | 0x2e,
	BL_AR_NB_SCANLINES	= BL_AREA_FEAT | BL_BIN_FEAT | 0x2f,
	BL_AR_SCANLINES	= BL_AREA_FEAT | BL_BIN_FEAT | 0x30,
	BL_AR_MIN	= BL_AREA_FEAT | BL_GRAY_FEAT | 0,
	BL_AR_MAX	= BL_AREA_FEAT | BL_GRAY_FEAT | 0x1,
	BL_AR_SUM	= BL_AREA_FEAT | BL_GRAY_FEAT | 0x2,
	BL_AR_SQUARED_SUM	= BL_AREA_FEAT | BL_GRAY_FEAT | 0x3,
	BL_AR_MEAN	= BL_AREA_FEAT | BL_GRAY_FEAT | 0x4,
	BL_AR_STDDEV	= BL_AREA_FEAT | BL_GRAY_FEAT | 0x5,
	BL_AR_SKEWNESS	= BL_AREA_FEAT | BL_GRAY_FEAT | 0x6,
	BL_AR_KURTOSIS	= BL_AREA_FEAT | BL_GRAY_FEAT | 0x7,
	BL_AR_SKEWNESS_FAC	= BL_AREA_FEAT | BL_GRAY_FEAT | 0x8,
	BL_AR_KURTOSIS_FAC	= BL_AREA_FEAT | BL_GRAY_FEAT | 0x9,
	BL_AR_ENTROPY	= BL_AREA_FEAT | BL_GRAY_FEAT | 0xa,
	BL_AR_VARCOEF	= BL_AREA_FEAT | BL_GRAY_FEAT | 0xb,
	BL_AR_HISTOGRAM	= BL_AREA_FEAT | BL_GRAY_FEAT | 0xf,
	BL_AR_CCMTX	= BL_AREA_FEAT | BL_GRAY_FEAT | 0x20,
	BL_AR_ENERGY	= BL_AREA_FEAT | BL_GRAY_FEAT | 0x21,
	BL_AR_CONTRAST	= BL_AREA_FEAT | BL_GRAY_FEAT | 0x22,
	BL_AR_ENTROPY_CCMTX	= BL_AREA_FEAT | BL_GRAY_FEAT | 0x23,
	BL_AR_CENTER_GRAVITY_X	= BL_AREA_FEAT | BL_GEN_FEAT | 0x40,
	BL_AR_CENTER_GRAVITY_Y	= BL_AREA_FEAT | BL_GEN_FEAT | 0x41,
	BL_AR_CENTER_GRAVITY	= BL_AREA_FEAT | BL_GEN_FEAT | 0x42,
	BL_AR_MOMENT_CENTRAL_X1_Y0	= BL_AREA_FEAT | BL_GEN_FEAT | 0x4e,
	BL_AR_MOMENT_CENTRAL_X0_Y1	= BL_AREA_FEAT | BL_GEN_FEAT | 0x4f,
	BL_AR_MOMENT_CENTRAL_X1_Y1	= BL_AREA_FEAT | BL_GEN_FEAT | 0x50,
	BL_AR_MOMENT_CENTRAL_X2_Y0	= BL_AREA_FEAT | BL_GEN_FEAT | 0x51,
	BL_AR_MOMENT_CENTRAL_X0_Y2	= BL_AREA_FEAT | BL_GEN_FEAT | 0x52,
	BL_AR_MOMENT_CENTRAL_X2_Y2	= BL_AREA_FEAT | BL_GEN_FEAT | 0x53,
	BL_AR_MOMENT_CENTRAL_X2_Y1	= BL_AREA_FEAT | BL_GEN_FEAT | 0x54,
	BL_AR_MOMENT_CENTRAL_X1_Y2	= BL_AREA_FEAT | BL_GEN_FEAT | 0x55,
	BL_AR_MOMENT_CENTRAL_X3_Y0	= BL_AREA_FEAT | BL_GEN_FEAT | 0x56,
	BL_AR_MOMENT_CENTRAL_X0_Y3	= BL_AREA_FEAT | BL_GEN_FEAT | 0x57,
	BL_AR_AXIS_SYMMETRY_ANGLE	= BL_AREA_FEAT | BL_GEN_FEAT | 0x58,
	BL_AR_AXIS_SYMMETRY_ANGLE_90	= BL_AREA_FEAT | BL_GEN_FEAT | 0x59,
	BL_AR_POLAR_DIST_MAX	= BL_AREA_FEAT | BL_GEN_FEAT | 0x5a,
	BL_AR_POLAR_DIST_MIN	= BL_AREA_FEAT | BL_GEN_FEAT | 0x5b,
	BL_AR_POLAR_DIST	= BL_AREA_FEAT | BL_GEN_FEAT | 0x5c
    } ;
typedef /* [hidden] */ enum BL_FEATURE BL_FEATURE;

struct BL_CCMTX
    {
    IPL_LONG dx;
    IPL_LONG dy;
    IPL_LONG Size;
    } ;
typedef struct BL_CCMTX BL_CCMTX;


EXTERN_C const IID LIBID_vl_blob;


#ifndef __vl_blob_MODULE_DEFINED__
#define __vl_blob_MODULE_DEFINED__


/* module vl_blob */
/* [dllname][uuid] */ 

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BL_Analyze( 
    /* [in] */ IPL_BUFHANDLE BinarySource,
    /* [in] */ IPL_BUFHANDLE GraySource,
    /* [full][out][in] */ IPL_BUFHANDLE *Destination,
    /* [in] */ BL_BUFHANDLE FeatureList,
    /* [in] */ BL_BUFHANDLE Result);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BL_BufAlloc( 
    /* [full][out] */ BL_BUFHANDLE *Buffer,
    /* [in] */ BL_BUFALLOCFLAGS Attribute);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BL_BufFree( 
    /* [in] */ BL_BUFHANDLE Buffer);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BL_FeatureSelect( 
    /* [in] */ BL_BUFHANDLE Buffer,
    /* [in] */ BL_FEATURE Feature,
    /* [full][in] */ IPL_CONST_VOID_PTR Item,
    /* [in] */ BL_FEATUREFLAGS Mode);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BL_GetCrdPoint( 
    /* [in] */ IPL_DOUBLE XPoint,
    /* [in] */ IPL_DOUBLE YPoint,
    /* [full][out] */ IPL_DOUBLE *XPointTrans,
    /* [full][out] */ IPL_DOUBLE *YPointTrans,
    /* [in] */ IPL_DOUBLE OrgX,
    /* [in] */ IPL_DOUBLE OrgY,
    /* [in] */ IPL_DOUBLE ScaleFaxX,
    /* [in] */ IPL_DOUBLE ScaleFacY,
    /* [in] */ IPL_DOUBLE RotationAngle);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BL_GetResultBufData( 
    /* [in] */ BL_BUFHANDLE Buffer,
    /* [in] */ IPL_ULONG Band,
    /* [in] */ IPL_ULONG Slice,
    /* [in] */ IPL_ULONG Frame,
    /* [in] */ BL_FEATURE Feature,
    /* [in] */ IPL_ULONG FeatureIndex,
    /* [full][out] */ IPL_VOID_PTR Data);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BL_ResultBufInquire( 
    /* [in] */ BL_BUFHANDLE Buffer,
    /* [in] */ IPL_ULONG Band,
    /* [in] */ IPL_ULONG Slice,
    /* [in] */ IPL_ULONG Frame,
    /* [in] */ BL_FEATURE Feature,
    /* [in] */ IPL_ULONG FeatureIndex,
    /* [in] */ BL_INQUIREFLAGS Item,
    /* [full][out] */ IPL_DOUBLE *Value);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BL_GetSingleResultBufData( 
    /* [in] */ BL_BUFHANDLE Buffer,
    /* [in] */ IPL_ULONG Band,
    /* [in] */ IPL_ULONG Slice,
    /* [in] */ IPL_ULONG Frame,
    /* [in] */ BL_FEATURE Feature,
    /* [in] */ IPL_ULONG FeatureIndex,
    /* [in] */ IPL_ULONG Index,
    /* [full][out] */ IPL_VOID_PTR Data);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BL_SetCrdSystem( 
    /* [in] */ BL_BUFHANDLE FeatureList,
    /* [in] */ IPL_DOUBLE OrgX,
    /* [in] */ IPL_DOUBLE OrgY,
    /* [in] */ IPL_DOUBLE ScaleFaxX,
    /* [in] */ IPL_DOUBLE ScaleFacY,
    /* [in] */ IPL_DOUBLE RotationAngle);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BL_GetCrdSystem( 
    /* [in] */ BL_BUFHANDLE FeatureList,
    /* [full][out] */ IPL_DOUBLE *OrgX,
    /* [full][out] */ IPL_DOUBLE *OrgY,
    /* [full][out] */ IPL_DOUBLE *ScaleFaxX,
    /* [full][out] */ IPL_DOUBLE *ScaleFacY,
    /* [full][out] */ IPL_DOUBLE *RotationAngle);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BL_SetProcMode( 
    /* [in] */ BL_BUFHANDLE Buffer,
    /* [in] */ BLOC_CONTROL Item,
    /* [in] */ IPL_LONG Value);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BL_GetProcMode( 
    /* [in] */ BL_BUFHANDLE Buffer,
    /* [in] */ BLOC_CONTROL Item,
    /* [out] */ IPL_LONG *Value);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BL_AnalyzeSingle( 
    BL_OBJHANDLE Handle,
    BL_BUFHANDLE BufHandleFeatureList,
    BL_BUFHANDLE BufHandleResult);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BL_CheckLic( void);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall BL_GetVersion( 
    /* [full][in] */ const IPL_CHAR *Buffer,
    /* [in] */ IPL_INT Bytes);

#endif /* __vl_blob_MODULE_DEFINED__ */
#endif /* __vl_blob_LIBRARY_DEFINED__ */

/* interface __MIDL_itf_vl_blob_0122 */
/* [local] */ 


#ifdef MVIMPACT_H_ // include guard of the main C++ header
	} // namespace mvIMPACT_C
} // namespace mvIMPACT
#endif // #ifdef MVIMPACT_H_



extern RPC_IF_HANDLE __MIDL_itf_vl_blob_0122_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_blob_0122_v0_0_s_ifspec;

/* Additional Prototypes for ALL interfaces */

/* end of Additional Prototypes */

#ifdef __cplusplus
}
#endif

#endif


