#ifdef _MSC_VER
#pragma warning ( push )
#pragma warning ( disable:4005 ) // '_WIN32_WINNT' : macro redefinition
#define _WIN32_WINNT 0x0500
#pragma warning ( pop )
#endif




#include "rpc.h"
#include "rpcndr.h"

#ifndef __RPCNDR_H_VERSION__
#error this stub requires an updated version of <rpcndr.h>
#endif // __RPCNDR_H_VERSION__


#ifndef __vl_compress_h__
#define __vl_compress_h__

#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

/* Forward Declarations */ 

/* header files for imported files */
#include "vl_base.h"

#ifdef __cplusplus
extern "C"{
#endif 

void * __RPC_USER MIDL_user_allocate(size_t);
void __RPC_USER MIDL_user_free( void * ); 

/* interface __MIDL_itf_vl_compress_0000 */
/* [local] */ 

//=--------------------------------------------------------------------------=
// (C) Copyright 2002-2010 MATRIX VISION GmbH.  All Rights Reserved.
// (C) Copyright 1997-2010 Impuls computergesttzte Bildanalyse GmbH.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//=--------------------------------------------------------------------------=

#if defined(__BORLANDC__)
#pragma option -b
#endif
#if !defined(NO_VL_COMPRESS_AUTOLINK)
#if defined(__BORLANDC__)
#pragma comment(lib,"vlb_compress.lib")
#pragma message ("Automatically linking with vlb_compress.lib")
#else
#if defined(_M_X64)
#if _MSC_VER >= 1500
#pragma comment(lib,"vl_compress.lib")
#pragma message ("Automatically linking with vl_compress.lib")
#else
#pragma comment(lib,"vl_compress64.lib")
#pragma message ("Automatically linking with vl_compress64.lib")
#endif
#else
#pragma comment(lib,"vl_compress.lib")
#pragma message ("Automatically linking with vl_compress.lib")
#endif
#endif
#endif


// Calling method for C Functions and C++ global and class methods.
// With other words: everything without a this-pointer
#define CMP_C_CALLTYPE __stdcall
#define CMP_C_CALLTYPEVAR __cdecl

// Calling method for the C++ methods with a this pointer.
// C++ static methods or C++ functions use CMP_C_CALLTYPE[VAR]
#define CMP_CPP_CALLTYPE // nothing == 'C++-call'
#define CMP_CPP_CALLTYPEVAR __cdecl

typedef /* [helpstring] */ char CMP_CHAR;

typedef /* [helpstring] */ unsigned long CMP_ULONG;

typedef /* [helpstring] */ void CMP_VOID;

typedef /* [helpstring] */ int CMP_FRESULT;

typedef /* [helpstring] */ CMP_FRESULT ( __stdcall *CMP_ONDONE_PTR )( 
    CMP_VOID *Ptr,
    CMP_ULONG Bytes,
    CMP_VOID *UserPtr);



extern RPC_IF_HANDLE __MIDL_itf_vl_compress_0000_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_compress_0000_v0_0_s_ifspec;


#ifndef __vl_compress_LIBRARY_DEFINED__
#define __vl_compress_LIBRARY_DEFINED__

/* library vl_compress */
/* [helpstring][version][uuid] */ 

/* [helpstring] */ 
enum CMP_ERROR
    {	CMP_COMPRESS_ERROR	= -4000,
	CMP_EXPAND_ERROR	= -4001,
	CMP_INVALID_INPUT_FILE	= -4002,
	CMP_INVALID_OUTPUT_FILE	= -4003,
	CMP_INVALID_PTR	= -4004
    } ;
typedef /* [hidden] */ enum CMP_ERROR CMP_ERROR;


EXTERN_C const IID LIBID_vl_compress;


#ifndef __vl_compress_MODULE_DEFINED__
#define __vl_compress_MODULE_DEFINED__


/* module vl_compress */
/* [dllname][uuid] */ 

/* [helpstring][entry] */ CMP_FRESULT __stdcall CMP_CompressFile( 
    /* [in] */ const CMP_CHAR *InputFile,
    /* [in] */ const CMP_CHAR *OutputFile);

/* [helpstring][entry] */ CMP_FRESULT __stdcall CMP_ExpandFile( 
    /* [in] */ const CMP_CHAR *InputFile,
    /* [in] */ const CMP_CHAR *OutputFile);

/* [helpstring][entry] */ CMP_FRESULT __stdcall CMP_CompressMemBlock( 
    /* [in] */ const CMP_CHAR *InputPtr,
    /* [in] */ CMP_ULONG Inbytes,
    /* [full][in] */ const CMP_VOID *FuncPtr,
    /* [full][in] */ CMP_VOID *UserPtr);

/* [helpstring][entry] */ CMP_FRESULT __stdcall CMP_ExpandMemBlock( 
    /* [full][in] */ const CMP_CHAR *InputPtr,
    /* [in] */ CMP_ULONG Inbytes,
    /* [full][in] */ const CMP_VOID *FuncPtr,
    /* [full][in] */ CMP_VOID *UserPtr);

/* [helpstring][entry] */ CMP_FRESULT __stdcall CMP_GetVersion( 
    /* [full][in] */ const IPL_CHAR *Buffer,
    /* [in] */ IPL_INT Bytes);

#endif /* __vl_compress_MODULE_DEFINED__ */
#endif /* __vl_compress_LIBRARY_DEFINED__ */

/* Additional Prototypes for ALL interfaces */

/* end of Additional Prototypes */

#ifdef __cplusplus
}
#endif

#endif


