#ifdef _MSC_VER
#pragma warning ( push )
#pragma warning ( disable:4005 ) // '_WIN32_WINNT' : macro redefinition
#define _WIN32_WINNT 0x0500
#pragma warning ( pop )
#endif




#include "rpc.h"
#include "rpcndr.h"

#ifndef __RPCNDR_H_VERSION__
#error this stub requires an updated version of <rpcndr.h>
#endif // __RPCNDR_H_VERSION__


#ifndef __vl_driver_h__
#define __vl_driver_h__

#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

/* Forward Declarations */ 

/* header files for imported files */
#include "vl_base.h"

#ifdef __cplusplus
extern "C"{
#endif 

void * __RPC_USER MIDL_user_allocate(size_t);
void __RPC_USER MIDL_user_free( void * ); 

/* interface __MIDL_itf_vl_driver_0000 */
/* [local] */ 

//=--------------------------------------------------------------------------=
// (C) Copyright 2002-2010 MATRIX VISION GmbH.  All Rights Reserved.
// (C) Copyright 1997-2010 Impuls computergesttzte Bildanalyse GmbH.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//=--------------------------------------------------------------------------=

#ifndef NO_VL_BASE_AUTOLINK
#define NO_VL_BASE_AUTOLINK
#endif //NO_VL_BASE_AUTOLINK

#ifdef MVIMPACT_H_ // include guard of the main C++ header
namespace mvIMPACT {
	namespace mvIMPACT_C {
#endif // #ifdef MVIMPACT_H_

#if defined(__BORLANDC__)
#pragma option -b
#endif

// Calling method for C Functions and C++ global and class methods.
// With other words: everything without a this-pointer
#define IPL_C_CALLTYPE __stdcall
#define IPL_C_CALLTYPEVAR __cdecl

// Calling method for the C++ methods with a this pointer.
// C++ static methods or C++ functions use IPL_C_CALLTYPE[VAR]
#define IPL_CPP_CALLTYPE // nothing == 'C++-call'
#define IPL_CPP_CALLTYPEVAR __cdecl

typedef /* [helpstring] */ IPL_BOOL ( __stdcall *FN )( 
    IPL_LONG __MIDL_0026,
    IPL_LONG __MIDL_0027,
    IPL_VOID_PTR __MIDL_0028,
    IPL_VOID_PTR __MIDL_0029,
    IPL_VOID_PTR __MIDL_0030);

typedef /* [helpstring] */ IPL_BOOL ( __stdcall *IF )( 
    IPL_VOID_PTR __MIDL_0032);

typedef /* [helpstring] */ IPL_BOOL ( __stdcall *FSFN )( 
    IPL_VOID_PTR __MIDL_0034);

typedef IPL_INT DRV_DISP_RETURN;

typedef DRV_DISP_RETURN ( __stdcall *DRV_DISPATCH_PROC )( 
    IPL_LONG __MIDL_0036,
    void *__MIDL_0037,
    void *__MIDL_0038,
    void *__MIDL_0039);

#define	MAX_IDENT	( 64 )

#define	IPL_CACHE_WRITE_THROUGH	( 0x4000000 )

#define	IPL_SEQUENTIAL_ACCESS	( 0x2000000 )

#define	IPL_RANDOM_ACCESS	( 0x1000000 )

#define	IPL_READONLY	( 0x400000 )

#define	IPL_USER_PROVIDED_MEM	( 0x200000 )

/* [helpstring] */ 
enum DCTL_CAPSTYPE
    {	DEV_INPUT_CHANNEL	= 95,
	DEV_LOW_REF	= 96,
	DEV_HIGH_REF	= 97,
	DEV_TRIGGER	= 98,
	DEV_CAPWINDOW_WIDTH	= 100,
	DEV_CAPWINDOW_HEIGHT	= 101,
	DEV_CAPWINDOW_XPOS	= 102,
	DEV_CAPWINDOW_YPOS	= 103,
	DEV_BITS_PER_SAMPLE	= 104,
	DEV_SAMPLES_PER_PIXEL	= 105,
	DEV_CAPWINDOW_WIDTH_MAX	= 106,
	DEV_CAPWINDOW_HEIGHT_MAX	= 107,
	DEV_FORCE_ACQUIRE_DEVMEM	= 108,
	DEV_DOES_CFG_DLGBOX	= 140,
	DEV_DOES_GRAB	= 141,
	DEV_SHOW_IN_WORKSPACE	= 142,
	DEV_DOES_CAPWINDOW	= 143,
	DEV_MVS_EXPOSE	= 144,
	DEV_MVS_GAIN	= 145,
	DEV_MVS_QVGA	= 146,
	DEV_MVS_READ_SWITCH	= 147,
	DEV_MVS_FLASH_LIGHT	= 148,
	DEV_MVS_PITCH	= 149,
	DEV_BAYER_RED_GAIN	= 200,
	DEV_BAYER_RED_OFFSET	= 201,
	DEV_BAYER_GREEN_GAIN	= 202,
	DEV_BAYER_GREEN_OFFSET	= 203,
	DEV_BAYER_BLUE_GAIN	= 204,
	DEV_BAYER_BLUE_OFFSET	= 205,
	DEV_BAYER_DIGITAL_GAIN	= 206,
	DEV_BAYER_PARITY	= 207,
	DEV_BAYER_DISPLAY_GREEN_GAIN	= 208
    } ;
typedef /* [hidden] */ enum DCTL_CAPSTYPE DCTL_CAPSTYPE;

/* [helpstring] */ 
enum DCTL_DATAFORMAT
    {	DCTL_MONO8	= 1,
	DCTL_MONO16	= 2,
	DCTL_RGB32_PACKED	= 3,
	DCTL_RGB24_PACKED	= 4,
	DCTL_RGB15_PACKED	= 5,
	DCTL_RGB24_PLANAR	= 6,
	DCTL_MONO32	= 7,
	DCTL_MONO64_FLOAT	= 8,
	DCTL_RGB48_PLANAR	= 9
    } ;
typedef /* [hidden] */ enum DCTL_DATAFORMAT DCTL_DATAFORMAT;

/* [helpstring] */ 
enum DCTL_CONTROLCODES
    {	DCTL_BASE	= 1,
	DCTL_RESET	= DCTL_BASE + 0,
	DCTL_OPEN	= DCTL_BASE + 1,
	DCTL_CLOSE	= DCTL_BASE + 2,
	DCTL_ACQUIRE	= DCTL_BASE + 5,
	DCTL_ACQUIRE_DEVMEM	= DCTL_BASE + 6,
	DCTL_PASS_MAPLUT	= DCTL_BASE + 7,
	DCTL_PASS_DISLUT	= DCTL_BASE + 8,
	DCTL_PRE_TRANSLATE_MESSAGE	= DCTL_BASE + 10000,
	DCTL_GET_FRAME_BUFFER_NUM	= DCTL_BASE + 1000,
	DCTL_GET_FRAME_BUFFER_ORG	= DCTL_BASE + 1001,
	DCTL_GET_INPUTLUT	= DCTL_BASE + 1002,
	DCTL_GET_INLUT_BUFFER_NUM	= DCTL_BASE + 1002,
	DCTL_GET_INPUTLUT_ORG	= DCTL_BASE + 1003,
	DCTL_GET_INLUT_BUFFER_ORG	= DCTL_BASE + 1003,
	DCTL_GET_OUTLUT_BUFFER_NUM	= DCTL_BASE + 1004,
	DCTL_GET_OUTLUT_BUFFER_ORG	= DCTL_BASE + 1005,
	DCTL_GET_DISPLUT_BUFFER_NUM	= DCTL_BASE + 1006,
	DCTL_GET_DISPLUT_BUFFER_ORG	= DCTL_BASE + 1007,
	DCTL_GET_CAPWINDOW_WIDTH	= DCTL_BASE + 1020,
	DCTL_GET_CAPWINDOW_HEIGHT	= DCTL_BASE + 1021,
	DCTL_GET_CAPWINDOW_XPOS	= DCTL_BASE + 1022,
	DCTL_GET_CAPWINDOW_YPOS	= DCTL_BASE + 1023,
	DCTL_GET_BITS_PER_SAMPLE	= DCTL_BASE + 1024,
	DCTL_GET_SAMPLES_PER_PIXEL	= DCTL_BASE + 1025,
	DCTL_GET_CHANNEL	= DCTL_BASE + 1049,
	DCTL_GET_CHANNEL_NUM	= DCTL_BASE + 1050,
	DCTL_GET_VERSION	= DCTL_BASE + 1051,
	DCTL_GET_TRIGGER_MODE	= DCTL_BASE + 1052,
	DCTL_GET_START_MODE	= DCTL_BASE + 1053,
	DCTL_GET_REFERENCE_LOW	= DCTL_BASE + 1054,
	DCTL_GET_REFERENCE_HIGH	= DCTL_BASE + 1055,
	DCTL_GET_REFERENCE_HUE	= DCTL_BASE + 1056,
	DCTL_GET_REFERENCE_SAT	= DCTL_BASE + 1057,
	DCTL_GET_REFERENCE_BRIGHT	= DCTL_BASE + 1058,
	DCTL_GET_REFERENCE_CONT	= DCTL_BASE + 1059,
	DCTL_GET_SCALE_X	= DCTL_BASE + 1060,
	DCTL_GET_SCALE_Y	= DCTL_BASE + 1061,
	DCTL_GET_LOGICAL_CAMERA	= DCTL_BASE + 1065,
	DCTL_GET_DOES_CFG_DLGBOX	= DCTL_BASE + 1066,
	DCTL_GET_DOES_GRAB	= DCTL_BASE + 1067,
	DCTL_GET_SHOW_IN_WORKSPACE	= DCTL_BASE + 1068,
	DCTL_GET_DATAFORMAT	= DCTL_BASE + 1070,
	DCTL_GET_NUMBER_FRAMES	= DCTL_BASE + 1071,
	DCTL_GET_CAPWINDOW_WIDTH_MAX	= DCTL_BASE + 1072,
	DCTL_GET_CAPWINDOW_HEIGHT_MAX	= DCTL_BASE + 1073,
	DCTL_GET_DOES_CAPWINDOW	= DCTL_BASE + 1074,
	DCTL_GET_MAPPING_INFO	= DCTL_BASE + 1075,
	DCTL_GET_TIMING_INFO	= DCTL_BASE + 1076,
	DCTL_GET_ILUMINATION_INFO	= DCTL_BASE + 1077,
	DCTL_SET_CAPWINDOW_WIDTH	= DCTL_BASE + 2020,
	DCTL_SET_CAPWINDOW_HEIGHT	= DCTL_BASE + 2021,
	DCTL_SET_CAPWINDOW_XPOS	= DCTL_BASE + 2022,
	DCTL_SET_CAPWINDOW_YPOS	= DCTL_BASE + 2023,
	DCTL_SET_MAPPING_INFO	= DCTL_BASE + 2024,
	DCTL_SET_POINTER_LIST	= DCTL_BASE + 2025,
	DCTL_SET_BITS_PER_SAMPLE	= DCTL_BASE + 2024,
	DCTL_SET_SAMPLES_PER_PIXEL	= DCTL_BASE + 2025,
	DCTL_SET_EXPOSURE_TIME	= DCTL_BASE + 2026,
	DCTL_SET_ILUMINATION_PARAMETERS	= DCTL_BASE + 2027,
	DCTL_SET_CHANNEL	= DCTL_BASE + 2049,
	DCTL_SET_CHANNEL_NUM	= DCTL_BASE + 2050,
	DCTL_SET_TRIGGER_MODE	= DCTL_BASE + 2052,
	DCTL_SET_START_MODE	= DCTL_BASE + 2053,
	DCTL_SET_REFERENCE_LOW	= DCTL_BASE + 2054,
	DCTL_SET_REFERENCE_HIGH	= DCTL_BASE + 2055,
	DCTL_SET_REFERENCE_HUE	= DCTL_BASE + 2056,
	DCTL_SET_REFERENCE_SAT	= DCTL_BASE + 2057,
	DCTL_SET_REFERENCE_BRIGHT	= DCTL_BASE + 2058,
	DCTL_SET_REFERENCE_CONT	= DCTL_BASE + 2059,
	DCTL_SET_SCALE_X	= DCTL_BASE + 2060,
	DCTL_SET_SCALE_Y	= DCTL_BASE + 2061,
	DCTL_SET_LOGICAL_CAMERA	= DCTL_BASE + 2065,
	DCTL_DATA_GET_LUT	= DCTL_BASE + 102,
	DCTL_DATA_PUT_LUT	= DCTL_BASE + 103,
	DCTL_NTF_SOSG	= DCTL_BASE + 400,
	DCTL_NTF_EOSG	= DCTL_BASE + 401,
	DCTL_NTF_SOCG	= DCTL_BASE + 402,
	DCTL_NTF_EOCG	= DCTL_BASE + 403,
	DCTL_NTF_SOFS	= DCTL_BASE + 404,
	DCTL_NTF_EOFS	= DCTL_BASE + 405,
	DCTL_NTF_SOFS_DEVMEM	= DCTL_BASE + 406,
	DCTL_NTF_EOFS_DEVMEM	= DCTL_BASE + 407,
	DRV_BASE	= 10000,
	DRV_NTF_SOSG	= DRV_BASE + 0,
	DRV_NTF_EOSG	= DRV_BASE + 1,
	DRV_NTF_SOCG	= DRV_BASE + 2,
	DRV_NTF_EOCG	= DRV_BASE + 3,
	DRV_NTF_EOF	= DRV_BASE + 4,
	DRV_NTF_SOACCG	= DRV_BASE + 5,
	DRV_NTF_EOACCG	= DRV_BASE + 6,
	DRV_NTF_SOSHADG	= DRV_BASE + 7,
	DRV_NTF_EOSHADG	= DRV_BASE + 8,
	DRV_NTF_SOOP	= DRV_BASE + 10,
	DRV_NTF_EOOP	= DRV_BASE + 11,
	DRV_NTF_CFG_CHANGED	= DRV_BASE + 12,
	DRV_NTF_EOCG_THREAD	= DRV_BASE + 13,
	DRV_SET_MAPPING_LUT	= DRV_BASE + 16,
	DCTL_OPEN_CONFIG_DLGBOX	= DCTL_BASE + 50,
	DCTL_OPEN_ABOUT_DLGBOX	= DCTL_BASE + 52,
	DCTL_SET_DBBFLAGS	= DCTL_BASE + 2069,
	DCTL_SET_SINGLE_DBBFLAG	= DCTL_BASE + 2070,
	DCTL_SET_FILE_FLAGS	= DCTL_BASE + 2071,
	DCTL_SET_BUFFER_FLAGS	= DCTL_BASE + 2072,
	DCTL_GET_FILE_FLAGS	= DCTL_BASE + 2073,
	DCTL_GET_MAPPING_PTR	= DCTL_BASE + 2074,
	DCTL_DO_DBB_MOVE	= DCTL_BASE + 2075,
	DCTL_DO_DBB_COPY	= DCTL_BASE + 2076,
	DCTL_GET_DBB_FILENAME_LENGTH	= DCTL_BASE + 2077,
	DCTL_GET_DBB_FILENAME	= DCTL_BASE + 2078,
	DCTL_GET_DBB_FILE_HANDLE	= DCTL_BASE + 2079,
	DCTL_DATA_GET_LINEAR	= DCTL_BASE + 2080,
	DCTL_DATA_PUT_LINEAR	= DCTL_BASE + 2081,
	DCTL_SET_DBB_DEFAULTPATH	= DCTL_BASE + 2082,
	DCTL_FREE_BUFFER	= DCTL_BASE + 30,
	DCTL_FREE_ALL_BUFFERS	= DCTL_BASE + 31,
	DCTL_ALLOC_BUFFER	= DCTL_BASE + 32,
	DCTL_TRANSLATE_CHILD	= DCTL_BASE + 33,
	DCTL_DATA_GET	= DCTL_BASE + 100,
	DCTL_DATA_PUT	= DCTL_BASE + 101,
	DCTL_CFG_SET	= DCTL_BASE + 201,
	DCTL_CFG_GET	= DCTL_BASE + 202,
	DCTL_CFG_GET_CUR	= DCTL_BASE + 203,
	DCTL_CFG_GET_NUM	= DCTL_BASE + 204,
	DCTL_GRAB	= DCTL_BASE + 301,
	DCTL_GRAB_CONT_HALT	= DCTL_BASE + 302,
	DCTL_SNAPSHOT	= DCTL_BASE + 303,
	DCTL_NTF_BEGIN_ACCESS	= DCTL_BASE + 500,
	DCTL_NTF_END_ACCESS	= DCTL_BASE + 501,
	DCTL_CUSTOMIZE_ACQUIRE_MENU	= DCTL_BASE + 600,
	DCTL_EXECUTE_ACQUIRE_COMMAND	= DCTL_BASE + 601,
	DCTL_CUSTOMIZE_CONTEXT_MENU	= DCTL_BASE + 602,
	DCTL_EXECUTE_CONTEXT_COMMAND	= DCTL_BASE + 603,
	DCTL_CUSTOMIZE_DRIVER_ICONS	= DCTL_BASE + 604,
	DCTL_GET_DRIVER_ICON_INDEX	= DCTL_BASE + 605,
	DCTL_GET_PTR	= DCTL_BASE + 2083,
	DCTL_RELEASE_PTR	= DCTL_BASE + 2084,
	DCTL_ENTER_NATIVE	= DCTL_BASE + 2085,
	DCTL_LEAVE_NATIVE	= DCTL_BASE + 2086,
	DCTL_GET_PROPERTY_COUNT	= DCTL_BASE + 2087,
	DCTL_GET_PROPERTY_LIST	= DCTL_BASE + 2088,
	DCTL_FREE_PROPERTY_LIST	= DCTL_BASE + 2089,
	DCTL_GET_INPUTCHANNEL	= DCTL_BASE + 2090,
	DCTL_SET_INPUTCHANNEL	= DCTL_BASE + 2091,
	DCTL_GET_TRIGGER	= DCTL_BASE + 2092,
	DCTL_SET_TRIGGER	= DCTL_BASE + 2093,
	DCTL_GET_LOWREF	= DCTL_BASE + 2094,
	DCTL_SET_LOWREF	= DCTL_BASE + 2095,
	DCTL_GET_HIGHREF	= DCTL_BASE + 2096,
	DCTL_SET_HIGHREF	= DCTL_BASE + 2097,
	DCTL_GET_VIDEOTYPE	= DCTL_BASE + 2098,
	DCTL_SET_VIDEOTYPE	= DCTL_BASE + 2099,
	DCTL_GET_CUSTOM_FEATURE	= DCTL_BASE + 2100,
	DCTL_SET_CUSTOM_FEATURE	= DCTL_BASE + 2101,
	DCTL_TWAIN_SELECT_SOURCE	= DCTL_BASE + 2102,
	DCTL_TWAIN_ACQUIRE	= DCTL_BASE + 2103,
	DCTL_TWAIN_XRES	= DCTL_BASE + 2104,
	DCTL_TWAIN_YRES	= DCTL_BASE + 2105,
	DCTL_TWAIN_PHY_WIDTH	= DCTL_BASE + 2106,
	DCTL_TWAIN_PHY_HEIGHT	= DCTL_BASE + 2107,
	DCTL_GET_DOES_LIVE_WINDOW	= DCTL_BASE + 1078,
	DCTL_GET_DOES_LIVE_WINDOW_SCROLL	= DCTL_BASE + 1079,
	DCTL_GET_DOES_LIVE_WINDOW_ZOOM	= DCTL_BASE + 1080,
	DCTL_GET_ENABLE_LIVE_WINDOW	= DCTL_BASE + 1081,
	DCTL_SET_ENABLE_LIVE_WINDOW	= DCTL_BASE + 2108,
	DCTL_SET_LIVE_WINDOW_SCROLL_POS	= DCTL_BASE + 2109,
	DCTL_SET_LIVE_WINDOW_ZOOM	= DCTL_BASE + 2110
    } ;
typedef /* [hidden] */ enum DCTL_CONTROLCODES DCTL_CONTROLCODES;

/* [helpstring] */ 
enum DCTL_NOTIFY
    {	DCTL_NOTHING_CHANGED	= -1,
	DCTL_MSG_NULL	= -2,
	DCTL_MSG_UNKNOWN	= -3
    } ;
typedef /* [hidden] */ enum DCTL_NOTIFY DCTL_NOTIFY;

/* [helpstring] */ 
enum DCTL_RANGETYPE
    {	DCTL_LNG_RANGE	= 1,
	DCTL_ULNG_RANGE	= 2,
	DCTL_DBL_RANGE	= 3,
	DCTL_NL_LNG_RANGE	= 4,
	DCTL_NL_ULNG_RANGE	= 5,
	DCTL_NL_DBL_RANGE	= 6,
	DCTL_LNG_ENUM	= 7,
	DCTL_DBL_ENUM	= 8,
	DCTL_STR_VALUE	= 9
    } ;
typedef /* [hidden] */ enum DCTL_RANGETYPE DCTL_RANGETYPE;

struct DSTR_LW_ENABLE
    {
    IPL_HWND Hwnd;
    } ;
typedef struct DSTR_LW_ENABLE DSTR_LW_ENABLE;

struct DSTR_LW_SCROLL_POS
    {
    IPL_LONG XPos;
    IPL_LONG YPos;
    } ;
typedef struct DSTR_LW_SCROLL_POS DSTR_LW_SCROLL_POS;

struct DSTR_LW_ZOOM
    {
    IPL_DOUBLE XZoom;
    IPL_DOUBLE YZoom;
    } ;
typedef struct DSTR_LW_ZOOM DSTR_LW_ZOOM;

struct DSTR_PROPERTY_LIST
    {
    IPL_LONG Id;
    IPL_CHAR *Name;
    IPL_CHAR *Unit;
    DCTL_RANGETYPE Type;
    IPL_VOID_PTR DataPtr;
    } ;
typedef struct DSTR_PROPERTY_LIST DSTR_PROPERTY_LIST;

struct DSTR_LNG_RANGE
    {
    IPL_LONG Min;
    IPL_LONG Max;
    IPL_LONG Increment;
    IPL_LONG Default;
    } ;
typedef struct DSTR_LNG_RANGE DSTR_LNG_RANGE;

struct DSTR_ULNG_RANGE
    {
    IPL_ULONG Min;
    IPL_ULONG Max;
    IPL_ULONG Increment;
    IPL_ULONG Default;
    } ;
typedef struct DSTR_ULNG_RANGE DSTR_ULNG_RANGE;

struct DSTR_DBL_RANGE
    {
    IPL_DOUBLE Min;
    IPL_DOUBLE Max;
    IPL_DOUBLE Increment;
    IPL_DOUBLE Default;
    } ;
typedef struct DSTR_DBL_RANGE DSTR_DBL_RANGE;

struct DSTR_NL_LNG_RANGE
    {
    IPL_LONG Min;
    IPL_LONG Max;
    IPL_LONG Entries;
    IPL_LONG *DataPtr;
    IPL_LONG Default;
    } ;
typedef struct DSTR_NL_LNG_RANGE DSTR_NL_LNG_RANGE;

struct DSTR_NL_ULNG_RANGE
    {
    IPL_ULONG Min;
    IPL_ULONG Max;
    IPL_LONG Entries;
    IPL_ULONG *DataPtr;
    IPL_ULONG Default;
    } ;
typedef struct DSTR_NL_ULNG_RANGE DSTR_NL_ULNG_RANGE;

struct DSTR_NL_DBL_RANGE
    {
    IPL_DOUBLE Min;
    IPL_DOUBLE Max;
    IPL_LONG Entries;
    IPL_DOUBLE *DataPtr;
    IPL_DOUBLE Default;
    } ;
typedef struct DSTR_NL_DBL_RANGE DSTR_NL_DBL_RANGE;

struct DSTR_LNG_ENUM
    {
    IPL_LONG Entries;
    IPL_LONG *DataPtr;
    IPL_CHAR **NamePtr;
    IPL_LONG Default;
    } ;
typedef struct DSTR_LNG_ENUM DSTR_LNG_ENUM;

struct DSTR_DBL_ENUM
    {
    IPL_LONG Entries;
    IPL_DOUBLE *DataPtr;
    IPL_CHAR **NamePtr;
    IPL_DOUBLE Default;
    } ;
typedef struct DSTR_DBL_ENUM DSTR_DBL_ENUM;

struct DSTR_STR_VALUE
    {
    IPL_LONG MaxLength;
    } ;
typedef struct DSTR_STR_VALUE DSTR_STR_VALUE;

struct DSTR_PTR
    {
    IPL_LONG Size;
    IPL_LONG BufHandle;
    IPL_LONG XPos;
    IPL_LONG YPos;
    IPL_LONG XSize;
    IPL_LONG YSize;
    IPL_LONG Band;
    IPL_LONG Slice;
    IPL_LONG Frame;
    IPL_LONG Pitch;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_PTR DSTR_PTR;

struct DSTR_MAPPINGPRESET
    {
    IPL_LONG Size;
    IPL_BOOL bLinkPalette;
    IPL_BOOL bUpdateValues;
    IPL_LONG iLowerLevel;
    IPL_LONG iUpperLevel;
    } ;
typedef struct DSTR_MAPPINGPRESET DSTR_MAPPINGPRESET;

struct DSTR_TIMING_INFO
    {
    IPL_LONG Size;
    IPL_DOUBLE ExposureTime;
    IPL_DOUBLE CycleTime;
    } ;
typedef struct DSTR_TIMING_INFO DSTR_TIMING_INFO;

struct DSTR_ILUMINATION_INFO
    {
    IPL_LONG Size;
    IPL_DOUBLE Wavelength;
    IPL_DOUBLE BandWidth;
    } ;
typedef struct DSTR_ILUMINATION_INFO DSTR_ILUMINATION_INFO;

struct DSTR_POINTER_LIST
    {
    IPL_LONG Size;
    IPL_LONG BufHandle;
    IPL_LONG Pitch;
    IPL_LONG NbBandPtrs;
    IPL_LONG NbSlicePtrs;
    IPL_LONG NbTimePtrs;
    IPL_VOID_PTR *PointerList;
    } ;
typedef struct DSTR_POINTER_LIST DSTR_POINTER_LIST;

struct DSTR_LUTPROPERTIES
    {
    IPL_LONG Size;
    IPL_LONG LutHandle;
    IPL_LONG NbEntries;
    IPL_LONG NbBands;
    IPL_LONG BitDepth;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_LUTPROPERTIES DSTR_LUTPROPERTIES;

struct DSTR_INITIALIZE
    {
    IPL_LONG Size;
    IPL_CHAR *Path;
    IPL_CHAR *Params;
    IPL_LONG DevHandle;
    FN Func;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_INITIALIZE DSTR_INITIALIZE;

struct DSTR_MAPPING_INFO
    {
    IPL_LONG Size;
    IPL_BOOL bLinkPalette;
    IPL_BOOL bUpdateValues;
    IPL_LONG iLowerLevel;
    IPL_LONG iUpperLevel;
    IPL_BOOL bMakeFlank;
    } ;
typedef struct DSTR_MAPPING_INFO DSTR_MAPPING_INFO;

struct DSTR_SEQUENCE
    {
    IPL_LONG Size;
    IF Func;
    IPL_LONG DataFormat;
    IPL_LONG Pitch;
    IPL_HTHREAD ThreadHandle;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_SEQUENCE DSTR_SEQUENCE;

struct DSTR_FRAMEDATA
    {
    IPL_LONG Size;
    IPL_VOID_PTR PtrRed;
    IPL_VOID_PTR PtrGreen;
    IPL_VOID_PTR PtrBlue;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_FRAMEDATA DSTR_FRAMEDATA;

struct DSTR_LUTDATA
    {
    IPL_LONG Size;
    IPL_LONG NbEntries;
    IPL_LONG NbBands;
    IPL_LONG BitDepth;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_LUTDATA DSTR_LUTDATA;

struct DSTR_DATATRANSFER_LUT
    {
    IPL_LONG Size;
    IPL_LONG NbBand;
    IPL_LONG Offset;
    IPL_LONG NbEntries;
    IPL_LONG LutHandle;
    IPL_VOID_PTR DataPtr;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_DATATRANSFER_LUT DSTR_DATATRANSFER_LUT;

struct DSTR_DATATRANSFER_LINEAR
    {
    IPL_LONG Size;
    IPL_LONG BufHandle;
    IPL_DOUBLE Start;
    IPL_LONG XSize;
    IPL_LONG YSize;
    IPL_LONG LinePitch;
    IPL_VOID_PTR DataPtr;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_DATATRANSFER_LINEAR DSTR_DATATRANSFER_LINEAR;

struct DSTR_MAPPING_PTR
    {
    IPL_VOID_PTR pMap;
    } ;
typedef struct DSTR_MAPPING_PTR DSTR_MAPPING_PTR;

struct DSTR_BUFFERLIST
    {
    IPL_LONG Size;
    IPL_CHAR BufString[ 64 ];
    IPL_LONG BufHandle;
    IPL_LONG Id;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_BUFFERLIST DSTR_BUFFERLIST;

struct DSTR_FREE_BUFFER
    {
    IPL_LONG Size;
    IPL_LONG DevBufHandle;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_FREE_BUFFER DSTR_FREE_BUFFER;

struct DSTR_STRING
    {
    IPL_LONG Size;
    IPL_CHAR *String;
    IPL_LONG NbBytes;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_STRING DSTR_STRING;

struct DSTR_MEMORY_ORG
    {
    IPL_LONG Size;
    IPL_LONG NbBuffers;
    IPL_VOID_PTR BufProperties;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_MEMORY_ORG DSTR_MEMORY_ORG;

struct DSTR_BUFPROPERTIES
    {
    IPL_LONG Size;
    IPL_LONG XSize;
    IPL_LONG YSize;
    IPL_LONG NbBands;
    IPL_LONG NbZSlices;
    IPL_LONG NbTimeSlices;
    IPL_LONG DataType;
    IPL_LONG BitsPerSample;
    IPL_LONG BufHandle;
    IPL_LONG ParentBufHandle;
    IPL_LONG XOff;
    IPL_LONG YOff;
    IPL_LONG BdOff;
    IPL_LONG ZOff;
    IPL_LONG TOff;
    IPL_LONG OrgOff;
    IPL_CHAR *pIdentDbb;
    IPL_CHAR Ident[ 64 ];
    IPL_VOID_PTR Ptr;
    IPL_LONG Flags;
    IPL_HFILE hFile;
    } ;
typedef struct DSTR_BUFPROPERTIES DSTR_BUFPROPERTIES;

struct DSTR_GRABPROPERTIES
    {
    IPL_LONG Size;
    IPL_LONG XSize;
    IPL_LONG YSize;
    IPL_LONG NbBands;
    IPL_LONG BitDepth;
    IPL_LONG BitsPerSample;
    IPL_LONG BufHandle;
    IPL_CHAR Ident[ 64 ];
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_GRABPROPERTIES DSTR_GRABPROPERTIES;

struct DSTR_LUT_ORG
    {
    IPL_LONG Size;
    IPL_LONG NbPalettes;
    IPL_VOID_PTR PalProperties;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_LUT_ORG DSTR_LUT_ORG;

struct DSTR_DATATRANSFER
    {
    IPL_LONG Size;
    IPL_LONG DataType;
    IPL_LONG XPos;
    IPL_LONG YPos;
    IPL_LONG XSize;
    IPL_LONG YSize;
    IPL_LONG BdCrd;
    IPL_LONG ZCrd;
    IPL_LONG TCrd;
    IPL_LONG BufHandle;
    IPL_LONG LinePitch;
    IPL_VOID_PTR DataPtr;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_DATATRANSFER DSTR_DATATRANSFER;

struct DSTR_SAVE
    {
    IPL_LONG Size;
    IPL_LONG Tag;
    IPL_CHAR Path[ 256 ];
    IPL_CHAR DField[ 64 ];
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_SAVE DSTR_SAVE;

struct DSTR_LOAD
    {
    IPL_LONG Size;
    IPL_LONG Tag;
    IPL_LONG NbCfg;
    IPL_CHAR Path[ 256 ];
    IPL_CHAR DField[ 64 ];
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_LOAD DSTR_LOAD;

struct DSTR_GRABSETTINGS
    {
    IPL_LONG Size;
    IPL_LONG NbFrames;
    IPL_LONG DevBufHandle;
    IPL_LONG XPos;
    IPL_LONG YPos;
    IPL_LONG BdCrd;
    IPL_LONG ZCrd;
    IPL_LONG TCrd;
    IPL_LONG XSize;
    IPL_LONG YSize;
    IPL_LONG LinePitch;
    IPL_VOID_PTR DataPtrRed;
    IPL_VOID_PTR DataPtrGreen;
    IPL_VOID_PTR DataPtrBlue;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_GRABSETTINGS DSTR_GRABSETTINGS;

struct DSTR_FSINFO
    {
    IPL_LONG Size;
    FSFN FSfunc;
    IPL_LONG TransferMode;
    IPL_VOID_PTR Ptr;
    } ;
typedef struct DSTR_FSINFO DSTR_FSINFO;

struct DSTR_FSCB
    {
    IPL_LONG Size;
    IPL_LONG LinePitch;
    IPL_LONG Width;
    IPL_LONG Height;
    IPL_LONG BytesPerItem;
    IPL_LONG FrameNumber;
    IPL_VOID_PTR PtrRed;
    IPL_VOID_PTR PtrGreen;
    IPL_VOID_PTR PtrBlue;
    } ;
typedef struct DSTR_FSCB DSTR_FSCB;

struct DSTR_CUSTOMIZE_MENU
    {
    IPL_LONG Size;
    IPL_HMENU hMenu;
    IPL_UINT idFirst;
    IPL_UINT idLast;
    IPL_CHAR *pAmpersands;
    } ;
typedef /* [helpstring] */ struct DSTR_CUSTOMIZE_MENU DSTR_CUSTOMIZE_MENU;

struct DSTR_CUSTOMIZE_ICONS
    {
    IPL_LONG Size;
    IPL_INT iCount;
    IPL_HICON aIcons[ 10 ];
    } ;
typedef /* [helpstring] */ struct DSTR_CUSTOMIZE_ICONS DSTR_CUSTOMIZE_ICONS;



extern RPC_IF_HANDLE __MIDL_itf_vl_driver_0000_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_driver_0000_v0_0_s_ifspec;


#ifndef __vl_driver_LIBRARY_DEFINED__
#define __vl_driver_LIBRARY_DEFINED__

/* library vl_driver */
/* [helpstring][version][uuid] */ 


EXTERN_C const IID LIBID_vl_driver;


#ifndef __vl_driver_MODULE_DEFINED__
#define __vl_driver_MODULE_DEFINED__


/* module vl_driver */
/* [dllname][uuid] */ 

#endif /* __vl_driver_MODULE_DEFINED__ */
#endif /* __vl_driver_LIBRARY_DEFINED__ */

/* interface __MIDL_itf_vl_driver_0119 */
/* [local] */ 


#ifdef MVIMPACT_H_ // include guard of the main C++ header
	} // namespace mvIMPACT_C
} // namespace mvIMPACT
#endif // #ifdef MVIMPACT_H_



extern RPC_IF_HANDLE __MIDL_itf_vl_driver_0119_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_driver_0119_v0_0_s_ifspec;

/* Additional Prototypes for ALL interfaces */

/* end of Additional Prototypes */

#ifdef __cplusplus
}
#endif

#endif


