#ifdef _MSC_VER
#pragma warning ( push )
#pragma warning ( disable:4005 ) // '_WIN32_WINNT' : macro redefinition
#define _WIN32_WINNT 0x0500
#pragma warning ( pop )
#endif




#include "rpc.h"
#include "rpcndr.h"

#ifndef __RPCNDR_H_VERSION__
#error this stub requires an updated version of <rpcndr.h>
#endif // __RPCNDR_H_VERSION__


#ifndef __vl_dummy_h__
#define __vl_dummy_h__

#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

/* Forward Declarations */ 

/* header files for imported files */
#include "vl_base.h"

#ifdef __cplusplus
extern "C"{
#endif 

void * __RPC_USER MIDL_user_allocate(size_t);
void __RPC_USER MIDL_user_free( void * ); 

/* interface __MIDL_itf_vl_dummy_0000 */
/* [local] */ 

//=--------------------------------------------------------------------------=
// (C) Copyright 2002-2010 MATRIX VISION GmbH.  All Rights Reserved.
// (C) Copyright 1997-2010 Impuls computergesttzte Bildanalyse GmbH.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//=--------------------------------------------------------------------------=

#if defined(__BORLANDC__)
#pragma option -b
#endif
#if !defined(NO_VL_DUMMY_AUTOLINK)
#if defined(__BORLANDC__)
#pragma comment(lib,"vlb_dummy.lib")
#pragma message ("Automatically linking with vlb_dummy.lib")
#else
#if defined(_M_X64)
#if _MSC_VER >= 1500
#pragma comment(lib,"vl_dummy.lib")
#pragma message ("Automatically linking with vl_dummy.lib")
#else
#pragma comment(lib,"vl_dummy64.lib")
#pragma message ("Automatically linking with vl_dummy64.lib")
#endif
#else
#pragma comment(lib,"vl_dummy.lib")
#pragma message ("Automatically linking with vl_dummy.lib")
#endif
#endif
#endif


#ifdef MVIMPACT_H_ // include guard of the main C++ header
namespace mvIMPACT {
	namespace mvIMPACT_C {
#endif // #ifdef MVIMPACT_H_


// Calling method for C Functions and C++ global and class methods.
// With other words: everything without a this-pointer
#define IPL_C_CALLTYPE __stdcall
#define IPL_C_CALLTYPEVAR __cdecl

// Calling method for the C++ methods with a this pointer.
// C++ static methods or C++ functions use IPL_C_CALLTYPE[VAR]
#define IPL_CPP_CALLTYPE // nothing == 'C++-call'
#define IPL_CPP_CALLTYPEVAR __cdecl

#ifdef VL_DUMMY_COMPILING
// when compiling the dll
#define VL_DUMMY_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllexport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllexport)
#else
// when using the dll
#define VL_DUMMY_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLEXPORT
#define __MIDL_DECLSPEC_DLLEXPORT	__declspec(dllimport)
#undef __MIDL_DECLSPEC_DLLIMPORT
#define __MIDL_DECLSPEC_DLLIMPORT	__declspec(dllimport)
#endif


extern RPC_IF_HANDLE __MIDL_itf_vl_dummy_0000_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_dummy_0000_v0_0_s_ifspec;


#ifndef __vl_dummy_LIBRARY_DEFINED__
#define __vl_dummy_LIBRARY_DEFINED__

/* library vl_dummy */
/* [helpstring][version][uuid] */ 

/* [helpstring] */ 
enum DUMMY_ERROR
    {	DUMMY_SIZE_TOO_SMALL	= -1
    } ;
typedef /* [public] */ enum DUMMY_ERROR DUMMY_ERROR;


EXTERN_C const IID LIBID_vl_dummy;


#ifndef __vl_dummy_MODULE_DEFINED__
#define __vl_dummy_MODULE_DEFINED__


/* module vl_dummy */
/* [dllname][uuid] */ 

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DUMMY_Hello( 
    /* [full][out] */ IPL_CHAR *Hello,
    /* [in] */ IPL_ULONG Size);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DUMMY_Hello1( 
    /* [full][out] */ IPL_CHAR *Hello,
    /* [in] */ IPL_ULONG Size);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DUMMY_Hello2( 
    /* [full][out] */ IPL_CHAR *Hello,
    /* [in] */ IPL_ULONG Size);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DUMMY_Hello3( 
    /* [full][out] */ IPL_CHAR *Hello,
    /* [in] */ IPL_ULONG Size);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DUMMY_Hello4( 
    /* [full][out] */ IPL_CHAR *Hello,
    /* [in] */ IPL_ULONG Size);

/* [helpstring][entry] */ __MIDL_DECLSPEC_DLLIMPORT IPL_FRESULT __stdcall DUMMY_GetVersion( 
    /* [full][in] */ const IPL_CHAR *Buffer,
    /* [in] */ IPL_INT Bytes);

#endif /* __vl_dummy_MODULE_DEFINED__ */
#endif /* __vl_dummy_LIBRARY_DEFINED__ */

/* interface __MIDL_itf_vl_dummy_0119 */
/* [local] */ 


#ifdef MVIMPACT_H_ // include guard of the main C++ header
	} // namespace mvIMPACT_C
} // namespace mvIMPACT
#endif // #ifdef MVIMPACT_H_



extern RPC_IF_HANDLE __MIDL_itf_vl_dummy_0119_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_vl_dummy_0119_v0_0_s_ifspec;

/* Additional Prototypes for ALL interfaces */

/* end of Additional Prototypes */

#ifdef __cplusplus
}
#endif

#endif


