#! /bin/make
##############################################
# Makefile for the 'crtool' PicoGUI demo,
# == DO NOT CHANGE !!! ==
# Don Apr 29 14:28:38 CEST 2004
##############################################
#-------------------------------------------
mvIMPACT=../../../..
mvBLUE=$(mvIMPACT)/../mvblue
IPKG_PATH=../ipkg
IPKG_DST_DIR=$(IPKG_PATH)/flash/picogui

#-------------------------------------------
MAJOR=1
MINOR1=2
MINOR2=2
IPK_VERSION:=$(MAJOR).$(MINOR1).$(MINOR2)

#-------------------------------------------
MODULE_NAME=crtool

#-------------------------------------------
OOBJ =										\
		pgtools.o gui.o preproc.o prop.o	\
		spinedit.o ftools.o gui_preproc.o	\

#-------------------------------------------
vpath %.cpp ..

#-------------------------------------------
IMPACT_LIBS =								\
		-lvl_device							\
		-lvl_display 						\
		-lvl_color							\
		-lBayer								\
		-lvl_cr1d							\
		-lvl_cr2d							\
		-lvl_ipl							\
		-lvl_file							\
		-lvl_base

#-------------------------------------------
ifeq ($(OSTYPE),cygwin)
	MVBL_PG_LIB=$(OSTYPE)603e
else
	MVBL_PG_LIB=$(TARGET)
endif

#-------------------------------------------
USR_INCLS =									\
	-I$(mvBLUE)/libs/pgutils

#-------------------------------------------
USR_LIBS =									\
	-L$(mvBLUE)/libs/pgutils/$(MVBL_PG_LIB)	\
		-lpgutils							\
	-L$(mvBLUE)/../mvIMPACTAcquire/lib/ppc603e				\
	-L$(GCCPATH)/usr/lib -lpgui				\
	-lexpat

#-------------------------------------------
CPPFLAGS_1 = 								\
		-DAPP_VERSION=\"$(IPK_VERSION)\"	\
#		-DDEBUG								\
#		-DMALLOC_TRACE						\
#		-DLINE_DEBUG						\

#-------------------------------------------
include ../../../Makefile.samp.inc

#-------------------------------------------
#-------------------------------------------


