//----------------------------------------------------------------------
//----------------------------------------------------------------------
// MATRIX VISION GmbH
// mvIMPACT - mvBlueLYNX demo >>gmmtool<<
// Don Nov 13 11:40:07 CET 2003
//----------------------------------------------------------------------

#ifndef __pgapi_h__
#define __pgapi_h__

//----------------------------------------------------------------------
//----------------------------------------------------------------------
#include <vector>
using namespace std;

#include <vl_base.h>
#include <vl_gmm.h>

#include "gmmtool.h"

//----------------------------------------------------------------------
//----------------------------------------------------------------------
void start_tool( int flag );
void init_gui( int argc, char *argv[], char *text );

void update_tms( );
void update_fps( );
void update_arc_cnt( );
void update_corner_cnt( );
void update_obj_cnt( );

void cp2disp( int mode );
void displ_img( );

SPIN_EDIT get_se( struct pgEvent *evt, long *se_cnt, unsigned int *step );
void set_val_from_se( struct pgEvent *evt, int val );

int evtClose( struct pgEvent *evt );
int evtLiveOFF( struct pgEvent *evt );

int cp_bin_img( IPL_BUFHANDLE bin_image );

int mk_new_context( );
void clear_canvas( );
void redraw_canvas( );

int gui_draw_circle( int x_cent, int y_cent, int r, int col_index );
int gui_draw_line( int x1, int y1, int x2, int y2, int col_index );
int gui_draw_text( int x, int y, char *text, int col_index );
int gui_draw_point( int x, int y, int col_index );

void cp_pts2img( vector<IPL_POINT_FLOAT>& vPoints, int col_index );

//----------------------------------------------------------------------
//----------------------------------------------------------------------

#endif	// __pgapi_h__

//----------------------------------------------------------------------
//----------------------------------------------------------------------
