#! /bin/make
##############################################
# Makefile for the 'pgCalibration' mvbldemo,
# == DO NOT CHANGE !!! ==
# Di Nov  8 11:21:23 CET 2005
##############################################
#-------------------------------------------
mvIMPACT=../../../..
WORK=$(mvIMPACT)/..

#-------------------------------------------
MODULE_NAME=pgCalibration

#-------------------------------------------
PGTOOLS_DIR:=$(shell if [ -e $(mvIMPACT)/samples ]; then echo samples; fi )

ifeq ($(PGTOOLS_DIR),)
	PGTOOLS_DIR:=error_path
endif

PGTOOLS_PATH=$(mvIMPACT)/$(PGTOOLS_DIR)/picogui/libpgtools

#-------------------------------------------
OOBJ =									\

#-------------------------------------------
vpath %.cpp ..

#-------------------------------------------
IMPACT_LIBS =							\
		-lvl_device						\
		-lvl_display 					\
		-lvl_camcal						\
		-lvl_ipl 						\
		-lvl_base

#-------------------------------------------
USR_INCLS =								\
	-I$(PGTOOLS_PATH)					\
	-I$(mvIMPACT)/include/mvIMPACT_CPP	\

#-------------------------------------------
USR_LIBS =								\
	-lpgtools							\

#-------------------------------------------
CPPFLAGS_1 =							\
	-DPLATFORM_MVBL						\
	-DDBG_START_END=0					\

#-------------------------------------------
include ../../../Makefile.samp.inc

#-------------------------------------------
#-------------------------------------------


